// Generated by rstantools.  Do not edit by hand.

/*
    sccomp is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    sccomp is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with sccomp.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef MODELS_HPP
#define MODELS_HPP
#define STAN__SERVICES__COMMAND_HPP
#include <rstan/rstaninc.hpp>
// Code generated by Stan version 2.21.0
#include <stan/model/model_header.hpp>
namespace model_glm_multi_beta_binomial_namespace {
using std::istream;
using std::string;
using std::stringstream;
using std::vector;
using stan::io::dump;
using stan::math::lgamma;
using stan::model::prob_grad;
using namespace stan::math;
static int current_statement_begin__;
stan::io::program_reader prog_reader__() {
    stan::io::program_reader reader;
    reader.add_event(0, 0, "start", "model_glm_multi_beta_binomial");
    reader.add_event(337, 335, "end", "model_glm_multi_beta_binomial");
    return reader;
}
Eigen::Matrix<double, Eigen::Dynamic, 1>
Q_sum_to_zero_QR(const int& N, std::ostream* pstream__) {
    typedef double local_scalar_t__;
    typedef local_scalar_t__ fun_return_scalar_t__;
    const static bool propto__ = true;
    (void) propto__;
        local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // suppress unused var warning
    int current_statement_begin__ = -1;
    try {
        {
        current_statement_begin__ = 3;
        validate_non_negative_index("Q_r", "(2 * N)", (2 * N));
        Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, 1> Q_r((2 * N));
        stan::math::initialize(Q_r, DUMMY_VAR__);
        stan::math::fill(Q_r, DUMMY_VAR__);
        current_statement_begin__ = 5;
        for (int i = 1; i <= N; ++i) {
            current_statement_begin__ = 6;
            stan::model::assign(Q_r, 
                        stan::model::cons_list(stan::model::index_uni(i), stan::model::nil_index_list()), 
                        -(stan::math::sqrt(((N - i) / ((N - i) + 1.0)))), 
                        "assigning variable Q_r");
            current_statement_begin__ = 7;
            stan::model::assign(Q_r, 
                        stan::model::cons_list(stan::model::index_uni((i + N)), stan::model::nil_index_list()), 
                        inv_sqrt(((N - i) * ((N - i) + 1))), 
                        "assigning variable Q_r");
        }
        current_statement_begin__ = 9;
        return stan::math::promote_scalar<fun_return_scalar_t__>(Q_r);
        }
    } catch (const std::exception& e) {
        stan::lang::rethrow_located(e, current_statement_begin__, prog_reader__());
        // Next line prevents compiler griping about no return
        throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
    }
}
struct Q_sum_to_zero_QR_functor__ {
            Eigen::Matrix<double, Eigen::Dynamic, 1>
    operator()(const int& N, std::ostream* pstream__) const {
        return Q_sum_to_zero_QR(N, pstream__);
    }
};
template <typename T0__, typename T1__>
Eigen::Matrix<typename boost::math::tools::promote_args<T0__, T1__>::type, 1, Eigen::Dynamic>
sum_to_zero_QR(const Eigen::Matrix<T0__, 1, Eigen::Dynamic>& x_raw,
                   const Eigen::Matrix<T1__, Eigen::Dynamic, 1>& Q_r, std::ostream* pstream__) {
    typedef typename boost::math::tools::promote_args<T0__, T1__>::type local_scalar_t__;
    typedef local_scalar_t__ fun_return_scalar_t__;
    const static bool propto__ = true;
    (void) propto__;
        local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // suppress unused var warning
    int current_statement_begin__ = -1;
    try {
        {
        current_statement_begin__ = 13;
        int N(0);
        (void) N;  // dummy to suppress unused var warning
        stan::math::fill(N, std::numeric_limits<int>::min());
        stan::math::assign(N,(num_elements(x_raw) + 1));
        current_statement_begin__ = 14;
        validate_non_negative_index("x", "N", N);
        Eigen::Matrix<local_scalar_t__, 1, Eigen::Dynamic> x(N);
        stan::math::initialize(x, DUMMY_VAR__);
        stan::math::fill(x, DUMMY_VAR__);
        current_statement_begin__ = 15;
        local_scalar_t__ x_aux(DUMMY_VAR__);
        (void) x_aux;  // dummy to suppress unused var warning
        stan::math::initialize(x_aux, DUMMY_VAR__);
        stan::math::fill(x_aux, DUMMY_VAR__);
        stan::math::assign(x_aux,0);
        current_statement_begin__ = 17;
        for (int i = 1; i <= (N - 1); ++i) {
            current_statement_begin__ = 18;
            stan::model::assign(x, 
                        stan::model::cons_list(stan::model::index_uni(i), stan::model::nil_index_list()), 
                        (x_aux + (get_base1(x_raw, i, "x_raw", 1) * get_base1(Q_r, i, "Q_r", 1))), 
                        "assigning variable x");
            current_statement_begin__ = 19;
            stan::math::assign(x_aux, (x_aux + (get_base1(x_raw, i, "x_raw", 1) * get_base1(Q_r, (i + N), "Q_r", 1))));
        }
        current_statement_begin__ = 21;
        stan::model::assign(x, 
                    stan::model::cons_list(stan::model::index_uni(N), stan::model::nil_index_list()), 
                    x_aux, 
                    "assigning variable x");
        current_statement_begin__ = 22;
        return stan::math::promote_scalar<fun_return_scalar_t__>(x);
        }
    } catch (const std::exception& e) {
        stan::lang::rethrow_located(e, current_statement_begin__, prog_reader__());
        // Next line prevents compiler griping about no return
        throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
    }
}
struct sum_to_zero_QR_functor__ {
    template <typename T0__, typename T1__>
        Eigen::Matrix<typename boost::math::tools::promote_args<T0__, T1__>::type, 1, Eigen::Dynamic>
    operator()(const Eigen::Matrix<T0__, 1, Eigen::Dynamic>& x_raw,
                   const Eigen::Matrix<T1__, Eigen::Dynamic, 1>& Q_r, std::ostream* pstream__) const {
        return sum_to_zero_QR(x_raw, Q_r, pstream__);
    }
};
template <typename T0__, typename T1__>
Eigen::Matrix<typename boost::math::tools::promote_args<T0__, T1__>::type, Eigen::Dynamic, 1>
sum_to_zero_QR_vector(const Eigen::Matrix<T0__, Eigen::Dynamic, 1>& x_raw,
                          const Eigen::Matrix<T1__, Eigen::Dynamic, 1>& Q_r, std::ostream* pstream__) {
    typedef typename boost::math::tools::promote_args<T0__, T1__>::type local_scalar_t__;
    typedef local_scalar_t__ fun_return_scalar_t__;
    const static bool propto__ = true;
    (void) propto__;
        local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // suppress unused var warning
    int current_statement_begin__ = -1;
    try {
        {
        current_statement_begin__ = 26;
        int N(0);
        (void) N;  // dummy to suppress unused var warning
        stan::math::fill(N, std::numeric_limits<int>::min());
        stan::math::assign(N,(num_elements(x_raw) + 1));
        current_statement_begin__ = 27;
        validate_non_negative_index("x", "N", N);
        Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, 1> x(N);
        stan::math::initialize(x, DUMMY_VAR__);
        stan::math::fill(x, DUMMY_VAR__);
        current_statement_begin__ = 28;
        local_scalar_t__ x_aux(DUMMY_VAR__);
        (void) x_aux;  // dummy to suppress unused var warning
        stan::math::initialize(x_aux, DUMMY_VAR__);
        stan::math::fill(x_aux, DUMMY_VAR__);
        stan::math::assign(x_aux,0);
        current_statement_begin__ = 30;
        for (int i = 1; i <= (N - 1); ++i) {
            current_statement_begin__ = 31;
            stan::model::assign(x, 
                        stan::model::cons_list(stan::model::index_uni(i), stan::model::nil_index_list()), 
                        (x_aux + (get_base1(x_raw, i, "x_raw", 1) * get_base1(Q_r, i, "Q_r", 1))), 
                        "assigning variable x");
            current_statement_begin__ = 32;
            stan::math::assign(x_aux, (x_aux + (get_base1(x_raw, i, "x_raw", 1) * get_base1(Q_r, (i + N), "Q_r", 1))));
        }
        current_statement_begin__ = 34;
        stan::model::assign(x, 
                    stan::model::cons_list(stan::model::index_uni(N), stan::model::nil_index_list()), 
                    x_aux, 
                    "assigning variable x");
        current_statement_begin__ = 35;
        return stan::math::promote_scalar<fun_return_scalar_t__>(x);
        }
    } catch (const std::exception& e) {
        stan::lang::rethrow_located(e, current_statement_begin__, prog_reader__());
        // Next line prevents compiler griping about no return
        throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
    }
}
struct sum_to_zero_QR_vector_functor__ {
    template <typename T0__, typename T1__>
        Eigen::Matrix<typename boost::math::tools::promote_args<T0__, T1__>::type, Eigen::Dynamic, 1>
    operator()(const Eigen::Matrix<T0__, Eigen::Dynamic, 1>& x_raw,
                          const Eigen::Matrix<T1__, Eigen::Dynamic, 1>& Q_r, std::ostream* pstream__) const {
        return sum_to_zero_QR_vector(x_raw, Q_r, pstream__);
    }
};
std::vector<int>
rep_each(const std::vector<int>& x,
             const int& K, std::ostream* pstream__) {
    typedef double local_scalar_t__;
    typedef int fun_return_scalar_t__;
    const static bool propto__ = true;
    (void) propto__;
        local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // suppress unused var warning
    int current_statement_begin__ = -1;
    try {
        {
        current_statement_begin__ = 39;
        int N(0);
        (void) N;  // dummy to suppress unused var warning
        stan::math::fill(N, std::numeric_limits<int>::min());
        stan::math::assign(N,size(x));
        current_statement_begin__ = 40;
        validate_non_negative_index("y", "(N * K)", (N * K));
        std::vector<int  > y((N * K), int(0));
        stan::math::fill(y, std::numeric_limits<int>::min());
        current_statement_begin__ = 41;
        int pos(0);
        (void) pos;  // dummy to suppress unused var warning
        stan::math::fill(pos, std::numeric_limits<int>::min());
        stan::math::assign(pos,1);
        current_statement_begin__ = 42;
        for (int n = 1; n <= N; ++n) {
            current_statement_begin__ = 43;
            for (int k = 1; k <= K; ++k) {
                current_statement_begin__ = 44;
                stan::model::assign(y, 
                            stan::model::cons_list(stan::model::index_uni(pos), stan::model::nil_index_list()), 
                            get_base1(x, n, "x", 1), 
                            "assigning variable y");
                current_statement_begin__ = 45;
                stan::math::assign(pos, (pos + 1));
            }
        }
        current_statement_begin__ = 48;
        return stan::math::promote_scalar<fun_return_scalar_t__>(y);
        }
    } catch (const std::exception& e) {
        stan::lang::rethrow_located(e, current_statement_begin__, prog_reader__());
        // Next line prevents compiler griping about no return
        throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
    }
}
struct rep_each_functor__ {
            std::vector<int>
    operator()(const std::vector<int>& x,
             const int& K, std::ostream* pstream__) const {
        return rep_each(x, K, pstream__);
    }
};
template <typename T0__>
Eigen::Matrix<typename boost::math::tools::promote_args<T0__>::type, 1, Eigen::Dynamic>
average_by_col(const Eigen::Matrix<T0__, Eigen::Dynamic, Eigen::Dynamic>& beta, std::ostream* pstream__) {
    typedef typename boost::math::tools::promote_args<T0__>::type local_scalar_t__;
    typedef local_scalar_t__ fun_return_scalar_t__;
    const static bool propto__ = true;
    (void) propto__;
        local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // suppress unused var warning
    int current_statement_begin__ = -1;
    try {
        current_statement_begin__ = 52;
        return stan::math::promote_scalar<fun_return_scalar_t__>(divide(multiply(rep_row_vector(1.0, rows(beta)), beta), rows(beta)));
    } catch (const std::exception& e) {
        stan::lang::rethrow_located(e, current_statement_begin__, prog_reader__());
        // Next line prevents compiler griping about no return
        throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
    }
}
struct average_by_col_functor__ {
    template <typename T0__>
        Eigen::Matrix<typename boost::math::tools::promote_args<T0__>::type, 1, Eigen::Dynamic>
    operator()(const Eigen::Matrix<T0__, Eigen::Dynamic, Eigen::Dynamic>& beta, std::ostream* pstream__) const {
        return average_by_col(beta, pstream__);
    }
};
template <typename T0__, typename T1__, typename T2__, typename T3__, typename T5__>
typename boost::math::tools::promote_args<T0__, T1__, T2__, T3__, typename boost::math::tools::promote_args<T5__>::type>::type
abundance_variability_regression(const Eigen::Matrix<T0__, 1, Eigen::Dynamic>& variability,
                                     const Eigen::Matrix<T1__, 1, Eigen::Dynamic>& abundance,
                                     const std::vector<T2__>& prec_coeff,
                                     const T3__& prec_sd,
                                     const int& bimodal_mean_variability_association,
                                     const T5__& mix_p, std::ostream* pstream__) {
    typedef typename boost::math::tools::promote_args<T0__, T1__, T2__, T3__, typename boost::math::tools::promote_args<T5__>::type>::type local_scalar_t__;
    typedef local_scalar_t__ fun_return_scalar_t__;
    const static bool propto__ = true;
    (void) propto__;
        local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // suppress unused var warning
    int current_statement_begin__ = -1;
    try {
        {
        current_statement_begin__ = 58;
        local_scalar_t__ lp(DUMMY_VAR__);
        (void) lp;  // dummy to suppress unused var warning
        stan::math::initialize(lp, DUMMY_VAR__);
        stan::math::fill(lp, DUMMY_VAR__);
        stan::math::assign(lp,0);
        current_statement_begin__ = 60;
        if (as_bool(logical_eq(bimodal_mean_variability_association, 1))) {
            current_statement_begin__ = 61;
            for (int m = 1; m <= cols(variability); ++m) {
                current_statement_begin__ = 62;
                stan::math::assign(lp, (lp + log_mix(mix_p, normal_log(get_base1(variability, m, "variability", 1), ((get_base1(abundance, m, "abundance", 1) * get_base1(prec_coeff, 2, "prec_coeff", 1)) + get_base1(prec_coeff, 1, "prec_coeff", 1)), prec_sd), normal_log(get_base1(variability, m, "variability", 1), ((get_base1(abundance, m, "abundance", 1) * get_base1(prec_coeff, 2, "prec_coeff", 1)) + 1), prec_sd))));
            }
        } else {
            current_statement_begin__ = 69;
            stan::math::assign(lp, normal_log(variability, add(multiply(abundance, get_base1(prec_coeff, 2, "prec_coeff", 1)), get_base1(prec_coeff, 1, "prec_coeff", 1)), prec_sd));
        }
        current_statement_begin__ = 72;
        return stan::math::promote_scalar<fun_return_scalar_t__>(lp);
        }
    } catch (const std::exception& e) {
        stan::lang::rethrow_located(e, current_statement_begin__, prog_reader__());
        // Next line prevents compiler griping about no return
        throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
    }
}
struct abundance_variability_regression_functor__ {
    template <typename T0__, typename T1__, typename T2__, typename T3__, typename T5__>
        typename boost::math::tools::promote_args<T0__, T1__, T2__, T3__, typename boost::math::tools::promote_args<T5__>::type>::type
    operator()(const Eigen::Matrix<T0__, 1, Eigen::Dynamic>& variability,
                                     const Eigen::Matrix<T1__, 1, Eigen::Dynamic>& abundance,
                                     const std::vector<T2__>& prec_coeff,
                                     const T3__& prec_sd,
                                     const int& bimodal_mean_variability_association,
                                     const T5__& mix_p, std::ostream* pstream__) const {
        return abundance_variability_regression(variability, abundance, prec_coeff, prec_sd, bimodal_mean_variability_association, mix_p, pstream__);
    }
};
#include <stan_meta_header.hpp>
class model_glm_multi_beta_binomial
  : public stan::model::model_base_crtp<model_glm_multi_beta_binomial> {
private:
        int N;
        int M;
        int C;
        int A;
        int A_intercept_columns;
        int Ar;
        std::vector<int> exposure;
        std::vector<std::vector<int> > y;
        matrix_d X;
        matrix_d XA;
        matrix_d Xa;
        int is_truncated;
        std::vector<std::vector<int> > truncation_up;
        std::vector<std::vector<int> > truncation_down;
        int TNS;
        std::vector<int> truncation_not_idx;
        int is_vb;
        std::vector<double> prior_prec_intercept;
        std::vector<double> prior_prec_slope;
        std::vector<double> prior_prec_sd;
        int exclude_priors;
        int bimodal_mean_variability_association;
        int use_data;
        int intercept_in_design;
        int N_random_intercepts;
        int N_minus_sum;
        std::vector<std::vector<int> > paring_cov_random_intercept;
        int N_grouping;
        matrix_d X_random_intercept;
        std::vector<std::vector<int> > idx_group_random_intercepts;
        int enable_loo;
        vector_d Q_r;
        double x_raw_sigma;
        matrix_d Q_ast;
        matrix_d R_ast;
        matrix_d R_ast_inverse;
        std::vector<int> y_array;
        std::vector<int> truncation_down_array;
        std::vector<int> exposure_array;
        int N_grouping_WINDOWS_BUG_FIX;
public:
    model_glm_multi_beta_binomial(stan::io::var_context& context__,
        std::ostream* pstream__ = 0)
        : model_base_crtp(0) {
        ctor_body(context__, 0, pstream__);
    }
    model_glm_multi_beta_binomial(stan::io::var_context& context__,
        unsigned int random_seed__,
        std::ostream* pstream__ = 0)
        : model_base_crtp(0) {
        ctor_body(context__, random_seed__, pstream__);
    }
    void ctor_body(stan::io::var_context& context__,
                   unsigned int random_seed__,
                   std::ostream* pstream__) {
        typedef double local_scalar_t__;
        boost::ecuyer1988 base_rng__ =
          stan::services::util::create_rng(random_seed__, 0);
        (void) base_rng__;  // suppress unused var warning
        current_statement_begin__ = -1;
        static const char* function__ = "model_glm_multi_beta_binomial_namespace::model_glm_multi_beta_binomial";
        (void) function__;  // dummy to suppress unused var warning
        size_t pos__;
        (void) pos__;  // dummy to suppress unused var warning
        std::vector<int> vals_i__;
        std::vector<double> vals_r__;
        local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // suppress unused var warning
        try {
            // initialize data block variables from context__
            current_statement_begin__ = 77;
            context__.validate_dims("data initialization", "N", "int", context__.to_vec());
            N = int(0);
            vals_i__ = context__.vals_i("N");
            pos__ = 0;
            N = vals_i__[pos__++];
            check_greater_or_equal(function__, "N", N, 1);
            current_statement_begin__ = 78;
            context__.validate_dims("data initialization", "M", "int", context__.to_vec());
            M = int(0);
            vals_i__ = context__.vals_i("M");
            pos__ = 0;
            M = vals_i__[pos__++];
            check_greater_or_equal(function__, "M", M, 1);
            current_statement_begin__ = 79;
            context__.validate_dims("data initialization", "C", "int", context__.to_vec());
            C = int(0);
            vals_i__ = context__.vals_i("C");
            pos__ = 0;
            C = vals_i__[pos__++];
            check_greater_or_equal(function__, "C", C, 1);
            current_statement_begin__ = 80;
            context__.validate_dims("data initialization", "A", "int", context__.to_vec());
            A = int(0);
            vals_i__ = context__.vals_i("A");
            pos__ = 0;
            A = vals_i__[pos__++];
            check_greater_or_equal(function__, "A", A, 1);
            current_statement_begin__ = 81;
            context__.validate_dims("data initialization", "A_intercept_columns", "int", context__.to_vec());
            A_intercept_columns = int(0);
            vals_i__ = context__.vals_i("A_intercept_columns");
            pos__ = 0;
            A_intercept_columns = vals_i__[pos__++];
            check_greater_or_equal(function__, "A_intercept_columns", A_intercept_columns, 1);
            current_statement_begin__ = 82;
            context__.validate_dims("data initialization", "Ar", "int", context__.to_vec());
            Ar = int(0);
            vals_i__ = context__.vals_i("Ar");
            pos__ = 0;
            Ar = vals_i__[pos__++];
            check_greater_or_equal(function__, "Ar", Ar, 1);
            current_statement_begin__ = 83;
            validate_non_negative_index("exposure", "N", N);
            context__.validate_dims("data initialization", "exposure", "int", context__.to_vec(N));
            exposure = std::vector<int>(N, int(0));
            vals_i__ = context__.vals_i("exposure");
            pos__ = 0;
            size_t exposure_k_0_max__ = N;
            for (size_t k_0__ = 0; k_0__ < exposure_k_0_max__; ++k_0__) {
                exposure[k_0__] = vals_i__[pos__++];
            }
            current_statement_begin__ = 84;
            validate_non_negative_index("y", "N", N);
            validate_non_negative_index("y", "M", M);
            context__.validate_dims("data initialization", "y", "int", context__.to_vec(N,M));
            y = std::vector<std::vector<int> >(N, std::vector<int>(M, int(0)));
            vals_i__ = context__.vals_i("y");
            pos__ = 0;
            size_t y_k_0_max__ = N;
            size_t y_k_1_max__ = M;
            for (size_t k_1__ = 0; k_1__ < y_k_1_max__; ++k_1__) {
                for (size_t k_0__ = 0; k_0__ < y_k_0_max__; ++k_0__) {
                    y[k_0__][k_1__] = vals_i__[pos__++];
                }
            }
            current_statement_begin__ = 85;
            validate_non_negative_index("X", "N", N);
            validate_non_negative_index("X", "C", C);
            context__.validate_dims("data initialization", "X", "matrix_d", context__.to_vec(N,C));
            X = Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic>(N, C);
            vals_r__ = context__.vals_r("X");
            pos__ = 0;
            size_t X_j_2_max__ = C;
            size_t X_j_1_max__ = N;
            for (size_t j_2__ = 0; j_2__ < X_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < X_j_1_max__; ++j_1__) {
                    X(j_1__, j_2__) = vals_r__[pos__++];
                }
            }
            current_statement_begin__ = 86;
            validate_non_negative_index("XA", "Ar", Ar);
            validate_non_negative_index("XA", "A", A);
            context__.validate_dims("data initialization", "XA", "matrix_d", context__.to_vec(Ar,A));
            XA = Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic>(Ar, A);
            vals_r__ = context__.vals_r("XA");
            pos__ = 0;
            size_t XA_j_2_max__ = A;
            size_t XA_j_1_max__ = Ar;
            for (size_t j_2__ = 0; j_2__ < XA_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < XA_j_1_max__; ++j_1__) {
                    XA(j_1__, j_2__) = vals_r__[pos__++];
                }
            }
            current_statement_begin__ = 87;
            validate_non_negative_index("Xa", "N", N);
            validate_non_negative_index("Xa", "A", A);
            context__.validate_dims("data initialization", "Xa", "matrix_d", context__.to_vec(N,A));
            Xa = Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic>(N, A);
            vals_r__ = context__.vals_r("Xa");
            pos__ = 0;
            size_t Xa_j_2_max__ = A;
            size_t Xa_j_1_max__ = N;
            for (size_t j_2__ = 0; j_2__ < Xa_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < Xa_j_1_max__; ++j_1__) {
                    Xa(j_1__, j_2__) = vals_r__[pos__++];
                }
            }
            current_statement_begin__ = 90;
            context__.validate_dims("data initialization", "is_truncated", "int", context__.to_vec());
            is_truncated = int(0);
            vals_i__ = context__.vals_i("is_truncated");
            pos__ = 0;
            is_truncated = vals_i__[pos__++];
            current_statement_begin__ = 91;
            validate_non_negative_index("truncation_up", "N", N);
            validate_non_negative_index("truncation_up", "M", M);
            context__.validate_dims("data initialization", "truncation_up", "int", context__.to_vec(N,M));
            truncation_up = std::vector<std::vector<int> >(N, std::vector<int>(M, int(0)));
            vals_i__ = context__.vals_i("truncation_up");
            pos__ = 0;
            size_t truncation_up_k_0_max__ = N;
            size_t truncation_up_k_1_max__ = M;
            for (size_t k_1__ = 0; k_1__ < truncation_up_k_1_max__; ++k_1__) {
                for (size_t k_0__ = 0; k_0__ < truncation_up_k_0_max__; ++k_0__) {
                    truncation_up[k_0__][k_1__] = vals_i__[pos__++];
                }
            }
            current_statement_begin__ = 92;
            validate_non_negative_index("truncation_down", "N", N);
            validate_non_negative_index("truncation_down", "M", M);
            context__.validate_dims("data initialization", "truncation_down", "int", context__.to_vec(N,M));
            truncation_down = std::vector<std::vector<int> >(N, std::vector<int>(M, int(0)));
            vals_i__ = context__.vals_i("truncation_down");
            pos__ = 0;
            size_t truncation_down_k_0_max__ = N;
            size_t truncation_down_k_1_max__ = M;
            for (size_t k_1__ = 0; k_1__ < truncation_down_k_1_max__; ++k_1__) {
                for (size_t k_0__ = 0; k_0__ < truncation_down_k_0_max__; ++k_0__) {
                    truncation_down[k_0__][k_1__] = vals_i__[pos__++];
                }
            }
            current_statement_begin__ = 93;
            context__.validate_dims("data initialization", "TNS", "int", context__.to_vec());
            TNS = int(0);
            vals_i__ = context__.vals_i("TNS");
            pos__ = 0;
            TNS = vals_i__[pos__++];
            check_greater_or_equal(function__, "TNS", TNS, 1);
            check_less_or_equal(function__, "TNS", TNS, (N * M));
            current_statement_begin__ = 94;
            validate_non_negative_index("truncation_not_idx", "TNS", TNS);
            context__.validate_dims("data initialization", "truncation_not_idx", "int", context__.to_vec(TNS));
            truncation_not_idx = std::vector<int>(TNS, int(0));
            vals_i__ = context__.vals_i("truncation_not_idx");
            pos__ = 0;
            size_t truncation_not_idx_k_0_max__ = TNS;
            for (size_t k_0__ = 0; k_0__ < truncation_not_idx_k_0_max__; ++k_0__) {
                truncation_not_idx[k_0__] = vals_i__[pos__++];
            }
            size_t truncation_not_idx_i_0_max__ = TNS;
            for (size_t i_0__ = 0; i_0__ < truncation_not_idx_i_0_max__; ++i_0__) {
                check_greater_or_equal(function__, "truncation_not_idx[i_0__]", truncation_not_idx[i_0__], 1);
                check_less_or_equal(function__, "truncation_not_idx[i_0__]", truncation_not_idx[i_0__], (N * M));
            }
            current_statement_begin__ = 95;
            context__.validate_dims("data initialization", "is_vb", "int", context__.to_vec());
            is_vb = int(0);
            vals_i__ = context__.vals_i("is_vb");
            pos__ = 0;
            is_vb = vals_i__[pos__++];
            check_greater_or_equal(function__, "is_vb", is_vb, 0);
            check_less_or_equal(function__, "is_vb", is_vb, 1);
            current_statement_begin__ = 98;
            validate_non_negative_index("prior_prec_intercept", "2", 2);
            context__.validate_dims("data initialization", "prior_prec_intercept", "double", context__.to_vec(2));
            prior_prec_intercept = std::vector<double>(2, double(0));
            vals_r__ = context__.vals_r("prior_prec_intercept");
            pos__ = 0;
            size_t prior_prec_intercept_k_0_max__ = 2;
            for (size_t k_0__ = 0; k_0__ < prior_prec_intercept_k_0_max__; ++k_0__) {
                prior_prec_intercept[k_0__] = vals_r__[pos__++];
            }
            current_statement_begin__ = 99;
            validate_non_negative_index("prior_prec_slope", "2", 2);
            context__.validate_dims("data initialization", "prior_prec_slope", "double", context__.to_vec(2));
            prior_prec_slope = std::vector<double>(2, double(0));
            vals_r__ = context__.vals_r("prior_prec_slope");
            pos__ = 0;
            size_t prior_prec_slope_k_0_max__ = 2;
            for (size_t k_0__ = 0; k_0__ < prior_prec_slope_k_0_max__; ++k_0__) {
                prior_prec_slope[k_0__] = vals_r__[pos__++];
            }
            current_statement_begin__ = 100;
            validate_non_negative_index("prior_prec_sd", "2", 2);
            context__.validate_dims("data initialization", "prior_prec_sd", "double", context__.to_vec(2));
            prior_prec_sd = std::vector<double>(2, double(0));
            vals_r__ = context__.vals_r("prior_prec_sd");
            pos__ = 0;
            size_t prior_prec_sd_k_0_max__ = 2;
            for (size_t k_0__ = 0; k_0__ < prior_prec_sd_k_0_max__; ++k_0__) {
                prior_prec_sd[k_0__] = vals_r__[pos__++];
            }
            current_statement_begin__ = 103;
            context__.validate_dims("data initialization", "exclude_priors", "int", context__.to_vec());
            exclude_priors = int(0);
            vals_i__ = context__.vals_i("exclude_priors");
            pos__ = 0;
            exclude_priors = vals_i__[pos__++];
            check_greater_or_equal(function__, "exclude_priors", exclude_priors, 0);
            check_less_or_equal(function__, "exclude_priors", exclude_priors, 1);
            current_statement_begin__ = 104;
            context__.validate_dims("data initialization", "bimodal_mean_variability_association", "int", context__.to_vec());
            bimodal_mean_variability_association = int(0);
            vals_i__ = context__.vals_i("bimodal_mean_variability_association");
            pos__ = 0;
            bimodal_mean_variability_association = vals_i__[pos__++];
            check_greater_or_equal(function__, "bimodal_mean_variability_association", bimodal_mean_variability_association, 0);
            check_less_or_equal(function__, "bimodal_mean_variability_association", bimodal_mean_variability_association, 1);
            current_statement_begin__ = 105;
            context__.validate_dims("data initialization", "use_data", "int", context__.to_vec());
            use_data = int(0);
            vals_i__ = context__.vals_i("use_data");
            pos__ = 0;
            use_data = vals_i__[pos__++];
            check_greater_or_equal(function__, "use_data", use_data, 0);
            check_less_or_equal(function__, "use_data", use_data, 1);
            current_statement_begin__ = 108;
            context__.validate_dims("data initialization", "intercept_in_design", "int", context__.to_vec());
            intercept_in_design = int(0);
            vals_i__ = context__.vals_i("intercept_in_design");
            pos__ = 0;
            intercept_in_design = vals_i__[pos__++];
            check_greater_or_equal(function__, "intercept_in_design", intercept_in_design, 0);
            check_less_or_equal(function__, "intercept_in_design", intercept_in_design, 1);
            current_statement_begin__ = 111;
            context__.validate_dims("data initialization", "N_random_intercepts", "int", context__.to_vec());
            N_random_intercepts = int(0);
            vals_i__ = context__.vals_i("N_random_intercepts");
            pos__ = 0;
            N_random_intercepts = vals_i__[pos__++];
            current_statement_begin__ = 112;
            context__.validate_dims("data initialization", "N_minus_sum", "int", context__.to_vec());
            N_minus_sum = int(0);
            vals_i__ = context__.vals_i("N_minus_sum");
            pos__ = 0;
            N_minus_sum = vals_i__[pos__++];
            current_statement_begin__ = 113;
            validate_non_negative_index("paring_cov_random_intercept", "N_random_intercepts", N_random_intercepts);
            validate_non_negative_index("paring_cov_random_intercept", "2", 2);
            context__.validate_dims("data initialization", "paring_cov_random_intercept", "int", context__.to_vec(N_random_intercepts,2));
            paring_cov_random_intercept = std::vector<std::vector<int> >(N_random_intercepts, std::vector<int>(2, int(0)));
            vals_i__ = context__.vals_i("paring_cov_random_intercept");
            pos__ = 0;
            size_t paring_cov_random_intercept_k_0_max__ = N_random_intercepts;
            size_t paring_cov_random_intercept_k_1_max__ = 2;
            for (size_t k_1__ = 0; k_1__ < paring_cov_random_intercept_k_1_max__; ++k_1__) {
                for (size_t k_0__ = 0; k_0__ < paring_cov_random_intercept_k_0_max__; ++k_0__) {
                    paring_cov_random_intercept[k_0__][k_1__] = vals_i__[pos__++];
                }
            }
            current_statement_begin__ = 114;
            context__.validate_dims("data initialization", "N_grouping", "int", context__.to_vec());
            N_grouping = int(0);
            vals_i__ = context__.vals_i("N_grouping");
            pos__ = 0;
            N_grouping = vals_i__[pos__++];
            current_statement_begin__ = 115;
            validate_non_negative_index("X_random_intercept", "N", N);
            validate_non_negative_index("X_random_intercept", "N_grouping", N_grouping);
            context__.validate_dims("data initialization", "X_random_intercept", "matrix_d", context__.to_vec(N,N_grouping));
            X_random_intercept = Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic>(N, N_grouping);
            vals_r__ = context__.vals_r("X_random_intercept");
            pos__ = 0;
            size_t X_random_intercept_j_2_max__ = N_grouping;
            size_t X_random_intercept_j_1_max__ = N;
            for (size_t j_2__ = 0; j_2__ < X_random_intercept_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < X_random_intercept_j_1_max__; ++j_1__) {
                    X_random_intercept(j_1__, j_2__) = vals_r__[pos__++];
                }
            }
            current_statement_begin__ = 116;
            validate_non_negative_index("idx_group_random_intercepts", "N_grouping", N_grouping);
            validate_non_negative_index("idx_group_random_intercepts", "2", 2);
            context__.validate_dims("data initialization", "idx_group_random_intercepts", "int", context__.to_vec(N_grouping,2));
            idx_group_random_intercepts = std::vector<std::vector<int> >(N_grouping, std::vector<int>(2, int(0)));
            vals_i__ = context__.vals_i("idx_group_random_intercepts");
            pos__ = 0;
            size_t idx_group_random_intercepts_k_0_max__ = N_grouping;
            size_t idx_group_random_intercepts_k_1_max__ = 2;
            for (size_t k_1__ = 0; k_1__ < idx_group_random_intercepts_k_1_max__; ++k_1__) {
                for (size_t k_0__ = 0; k_0__ < idx_group_random_intercepts_k_0_max__; ++k_0__) {
                    idx_group_random_intercepts[k_0__][k_1__] = vals_i__[pos__++];
                }
            }
            current_statement_begin__ = 119;
            context__.validate_dims("data initialization", "enable_loo", "int", context__.to_vec());
            enable_loo = int(0);
            vals_i__ = context__.vals_i("enable_loo");
            pos__ = 0;
            enable_loo = vals_i__[pos__++];
            check_greater_or_equal(function__, "enable_loo", enable_loo, 0);
            check_less_or_equal(function__, "enable_loo", enable_loo, 1);
            // initialize transformed data variables
            current_statement_begin__ = 122;
            validate_non_negative_index("Q_r", "(2 * M)", (2 * M));
            Q_r = Eigen::Matrix<double, Eigen::Dynamic, 1>((2 * M));
            stan::math::fill(Q_r, DUMMY_VAR__);
            stan::math::assign(Q_r,Q_sum_to_zero_QR(M, pstream__));
            current_statement_begin__ = 123;
            x_raw_sigma = double(0);
            stan::math::fill(x_raw_sigma, DUMMY_VAR__);
            stan::math::assign(x_raw_sigma,inv_sqrt((1 - inv(M))));
            current_statement_begin__ = 124;
            validate_non_negative_index("Q_ast", "N", N);
            validate_non_negative_index("Q_ast", "C", C);
            Q_ast = Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic>(N, C);
            stan::math::fill(Q_ast, DUMMY_VAR__);
            current_statement_begin__ = 125;
            validate_non_negative_index("R_ast", "C", C);
            validate_non_negative_index("R_ast", "C", C);
            R_ast = Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic>(C, C);
            stan::math::fill(R_ast, DUMMY_VAR__);
            current_statement_begin__ = 126;
            validate_non_negative_index("R_ast_inverse", "C", C);
            validate_non_negative_index("R_ast_inverse", "C", C);
            R_ast_inverse = Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic>(C, C);
            stan::math::fill(R_ast_inverse, DUMMY_VAR__);
            current_statement_begin__ = 127;
            validate_non_negative_index("y_array", "(N * M)", (N * M));
            y_array = std::vector<int>((N * M), int(0));
            stan::math::fill(y_array, std::numeric_limits<int>::min());
            current_statement_begin__ = 128;
            validate_non_negative_index("truncation_down_array", "(N * M)", (N * M));
            truncation_down_array = std::vector<int>((N * M), int(0));
            stan::math::fill(truncation_down_array, std::numeric_limits<int>::min());
            current_statement_begin__ = 129;
            validate_non_negative_index("exposure_array", "(N * M)", (N * M));
            exposure_array = std::vector<int>((N * M), int(0));
            stan::math::fill(exposure_array, std::numeric_limits<int>::min());
            current_statement_begin__ = 131;
            N_grouping_WINDOWS_BUG_FIX = int(0);
            stan::math::fill(N_grouping_WINDOWS_BUG_FIX, std::numeric_limits<int>::min());
            stan::math::assign(N_grouping_WINDOWS_BUG_FIX,std::max(N_grouping, 1));
            // execute transformed data statements
            current_statement_begin__ = 133;
            stan::math::assign(Q_ast, multiply(qr_thin_Q(X), stan::math::sqrt((N - 1))));
            current_statement_begin__ = 134;
            stan::math::assign(R_ast_inverse, inverse(divide(qr_thin_R(X), stan::math::sqrt((N - 1)))));
            current_statement_begin__ = 136;
            if (as_bool(logical_gt(max(R_ast_inverse), 1000))) {
                current_statement_begin__ = 137;
                if (pstream__) {
                    stan_print(pstream__,"sccomp says: The QR deconposition resulted in extreme values, probably for the correlation structure of your design matrix. Omitting QR decomposition.");
                    *pstream__ << std::endl;
                }
                current_statement_begin__ = 138;
                stan::math::assign(Q_ast, X);
                current_statement_begin__ = 139;
                stan::math::assign(R_ast_inverse, diag_matrix(rep_vector(1.0, C)));
            }
            current_statement_begin__ = 142;
            stan::math::assign(y_array, to_array_1d(y));
            current_statement_begin__ = 143;
            stan::math::assign(truncation_down_array, to_array_1d(truncation_down));
            current_statement_begin__ = 144;
            stan::math::assign(exposure_array, rep_each(exposure, M, pstream__));
            // validate transformed data
            // validate, set parameter ranges
            num_params_r__ = 0U;
            param_ranges_i__.clear();
            current_statement_begin__ = 147;
            validate_non_negative_index("beta_raw_raw", "C", C);
            validate_non_negative_index("beta_raw_raw", "(M - 1)", (M - 1));
            num_params_r__ += (C * (M - 1));
            current_statement_begin__ = 148;
            validate_non_negative_index("alpha", "A", A);
            validate_non_negative_index("alpha", "M", M);
            num_params_r__ += (A * M);
            current_statement_begin__ = 150;
            validate_non_negative_index("prec_coeff", "2", 2);
            num_params_r__ += (1 * 2);
            current_statement_begin__ = 151;
            num_params_r__ += 1;
            current_statement_begin__ = 152;
            num_params_r__ += 1;
            current_statement_begin__ = 154;
            validate_non_negative_index("random_intercept_raw", "(N_random_intercepts * logical_gt(N_random_intercepts, 0))", (N_random_intercepts * logical_gt(N_random_intercepts, 0)));
            validate_non_negative_index("random_intercept_raw", "(M - 1)", (M - 1));
            num_params_r__ += ((N_random_intercepts * logical_gt(N_random_intercepts, 0)) * (M - 1));
            current_statement_begin__ = 156;
            validate_non_negative_index("random_intercept_sigma_mu", "logical_gt(N_random_intercepts, 0)", logical_gt(N_random_intercepts, 0));
            num_params_r__ += (1 * logical_gt(N_random_intercepts, 0));
            current_statement_begin__ = 157;
            validate_non_negative_index("random_intercept_sigma_sigma", "logical_gt(N_random_intercepts, 0)", logical_gt(N_random_intercepts, 0));
            num_params_r__ += (1 * logical_gt(N_random_intercepts, 0));
            current_statement_begin__ = 158;
            validate_non_negative_index("random_intercept_sigma_raw", "((M - 1) * logical_gt(N_random_intercepts, 0))", ((M - 1) * logical_gt(N_random_intercepts, 0)));
            num_params_r__ += ((M - 1) * logical_gt(N_random_intercepts, 0));
            current_statement_begin__ = 160;
            validate_non_negative_index("zero_random_intercept", "logical_gt(N_random_intercepts, 0)", logical_gt(N_random_intercepts, 0));
            num_params_r__ += (1 * logical_gt(N_random_intercepts, 0));
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(e, current_statement_begin__, prog_reader__());
            // Next line prevents compiler griping about no return
            throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
        }
    }
    ~model_glm_multi_beta_binomial() { }
    void transform_inits(const stan::io::var_context& context__,
                         std::vector<int>& params_i__,
                         std::vector<double>& params_r__,
                         std::ostream* pstream__) const {
        typedef double local_scalar_t__;
        stan::io::writer<double> writer__(params_r__, params_i__);
        size_t pos__;
        (void) pos__; // dummy call to supress warning
        std::vector<double> vals_r__;
        std::vector<int> vals_i__;
        current_statement_begin__ = 147;
        if (!(context__.contains_r("beta_raw_raw")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable beta_raw_raw missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("beta_raw_raw");
        pos__ = 0U;
        validate_non_negative_index("beta_raw_raw", "C", C);
        validate_non_negative_index("beta_raw_raw", "(M - 1)", (M - 1));
        context__.validate_dims("parameter initialization", "beta_raw_raw", "matrix_d", context__.to_vec(C,(M - 1)));
        Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> beta_raw_raw(C, (M - 1));
        size_t beta_raw_raw_j_2_max__ = (M - 1);
        size_t beta_raw_raw_j_1_max__ = C;
        for (size_t j_2__ = 0; j_2__ < beta_raw_raw_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < beta_raw_raw_j_1_max__; ++j_1__) {
                beta_raw_raw(j_1__, j_2__) = vals_r__[pos__++];
            }
        }
        try {
            writer__.matrix_unconstrain(beta_raw_raw);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable beta_raw_raw: ") + e.what()), current_statement_begin__, prog_reader__());
        }
        current_statement_begin__ = 148;
        if (!(context__.contains_r("alpha")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable alpha missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("alpha");
        pos__ = 0U;
        validate_non_negative_index("alpha", "A", A);
        validate_non_negative_index("alpha", "M", M);
        context__.validate_dims("parameter initialization", "alpha", "matrix_d", context__.to_vec(A,M));
        Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> alpha(A, M);
        size_t alpha_j_2_max__ = M;
        size_t alpha_j_1_max__ = A;
        for (size_t j_2__ = 0; j_2__ < alpha_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < alpha_j_1_max__; ++j_1__) {
                alpha(j_1__, j_2__) = vals_r__[pos__++];
            }
        }
        try {
            writer__.matrix_unconstrain(alpha);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable alpha: ") + e.what()), current_statement_begin__, prog_reader__());
        }
        current_statement_begin__ = 150;
        if (!(context__.contains_r("prec_coeff")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable prec_coeff missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("prec_coeff");
        pos__ = 0U;
        validate_non_negative_index("prec_coeff", "2", 2);
        context__.validate_dims("parameter initialization", "prec_coeff", "double", context__.to_vec(2));
        std::vector<double> prec_coeff(2, double(0));
        size_t prec_coeff_k_0_max__ = 2;
        for (size_t k_0__ = 0; k_0__ < prec_coeff_k_0_max__; ++k_0__) {
            prec_coeff[k_0__] = vals_r__[pos__++];
        }
        size_t prec_coeff_i_0_max__ = 2;
        for (size_t i_0__ = 0; i_0__ < prec_coeff_i_0_max__; ++i_0__) {
            try {
                writer__.scalar_unconstrain(prec_coeff[i_0__]);
            } catch (const std::exception& e) {
                stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable prec_coeff: ") + e.what()), current_statement_begin__, prog_reader__());
            }
        }
        current_statement_begin__ = 151;
        if (!(context__.contains_r("prec_sd")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable prec_sd missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("prec_sd");
        pos__ = 0U;
        context__.validate_dims("parameter initialization", "prec_sd", "double", context__.to_vec());
        double prec_sd(0);
        prec_sd = vals_r__[pos__++];
        try {
            writer__.scalar_lb_unconstrain(0, prec_sd);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable prec_sd: ") + e.what()), current_statement_begin__, prog_reader__());
        }
        current_statement_begin__ = 152;
        if (!(context__.contains_r("mix_p")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable mix_p missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("mix_p");
        pos__ = 0U;
        context__.validate_dims("parameter initialization", "mix_p", "double", context__.to_vec());
        double mix_p(0);
        mix_p = vals_r__[pos__++];
        try {
            writer__.scalar_lub_unconstrain(0, 1, mix_p);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable mix_p: ") + e.what()), current_statement_begin__, prog_reader__());
        }
        current_statement_begin__ = 154;
        if (!(context__.contains_r("random_intercept_raw")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable random_intercept_raw missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("random_intercept_raw");
        pos__ = 0U;
        validate_non_negative_index("random_intercept_raw", "(N_random_intercepts * logical_gt(N_random_intercepts, 0))", (N_random_intercepts * logical_gt(N_random_intercepts, 0)));
        validate_non_negative_index("random_intercept_raw", "(M - 1)", (M - 1));
        context__.validate_dims("parameter initialization", "random_intercept_raw", "matrix_d", context__.to_vec((N_random_intercepts * logical_gt(N_random_intercepts, 0)),(M - 1)));
        Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> random_intercept_raw((N_random_intercepts * logical_gt(N_random_intercepts, 0)), (M - 1));
        size_t random_intercept_raw_j_2_max__ = (M - 1);
        size_t random_intercept_raw_j_1_max__ = (N_random_intercepts * logical_gt(N_random_intercepts, 0));
        for (size_t j_2__ = 0; j_2__ < random_intercept_raw_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < random_intercept_raw_j_1_max__; ++j_1__) {
                random_intercept_raw(j_1__, j_2__) = vals_r__[pos__++];
            }
        }
        try {
            writer__.matrix_unconstrain(random_intercept_raw);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable random_intercept_raw: ") + e.what()), current_statement_begin__, prog_reader__());
        }
        current_statement_begin__ = 156;
        if (!(context__.contains_r("random_intercept_sigma_mu")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable random_intercept_sigma_mu missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("random_intercept_sigma_mu");
        pos__ = 0U;
        validate_non_negative_index("random_intercept_sigma_mu", "logical_gt(N_random_intercepts, 0)", logical_gt(N_random_intercepts, 0));
        context__.validate_dims("parameter initialization", "random_intercept_sigma_mu", "double", context__.to_vec(logical_gt(N_random_intercepts, 0)));
        std::vector<double> random_intercept_sigma_mu(logical_gt(N_random_intercepts, 0), double(0));
        size_t random_intercept_sigma_mu_k_0_max__ = logical_gt(N_random_intercepts, 0);
        for (size_t k_0__ = 0; k_0__ < random_intercept_sigma_mu_k_0_max__; ++k_0__) {
            random_intercept_sigma_mu[k_0__] = vals_r__[pos__++];
        }
        size_t random_intercept_sigma_mu_i_0_max__ = logical_gt(N_random_intercepts, 0);
        for (size_t i_0__ = 0; i_0__ < random_intercept_sigma_mu_i_0_max__; ++i_0__) {
            try {
                writer__.scalar_unconstrain(random_intercept_sigma_mu[i_0__]);
            } catch (const std::exception& e) {
                stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable random_intercept_sigma_mu: ") + e.what()), current_statement_begin__, prog_reader__());
            }
        }
        current_statement_begin__ = 157;
        if (!(context__.contains_r("random_intercept_sigma_sigma")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable random_intercept_sigma_sigma missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("random_intercept_sigma_sigma");
        pos__ = 0U;
        validate_non_negative_index("random_intercept_sigma_sigma", "logical_gt(N_random_intercepts, 0)", logical_gt(N_random_intercepts, 0));
        context__.validate_dims("parameter initialization", "random_intercept_sigma_sigma", "double", context__.to_vec(logical_gt(N_random_intercepts, 0)));
        std::vector<double> random_intercept_sigma_sigma(logical_gt(N_random_intercepts, 0), double(0));
        size_t random_intercept_sigma_sigma_k_0_max__ = logical_gt(N_random_intercepts, 0);
        for (size_t k_0__ = 0; k_0__ < random_intercept_sigma_sigma_k_0_max__; ++k_0__) {
            random_intercept_sigma_sigma[k_0__] = vals_r__[pos__++];
        }
        size_t random_intercept_sigma_sigma_i_0_max__ = logical_gt(N_random_intercepts, 0);
        for (size_t i_0__ = 0; i_0__ < random_intercept_sigma_sigma_i_0_max__; ++i_0__) {
            try {
                writer__.scalar_unconstrain(random_intercept_sigma_sigma[i_0__]);
            } catch (const std::exception& e) {
                stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable random_intercept_sigma_sigma: ") + e.what()), current_statement_begin__, prog_reader__());
            }
        }
        current_statement_begin__ = 158;
        if (!(context__.contains_r("random_intercept_sigma_raw")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable random_intercept_sigma_raw missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("random_intercept_sigma_raw");
        pos__ = 0U;
        validate_non_negative_index("random_intercept_sigma_raw", "((M - 1) * logical_gt(N_random_intercepts, 0))", ((M - 1) * logical_gt(N_random_intercepts, 0)));
        context__.validate_dims("parameter initialization", "random_intercept_sigma_raw", "row_vector_d", context__.to_vec(((M - 1) * logical_gt(N_random_intercepts, 0))));
        Eigen::Matrix<double, 1, Eigen::Dynamic> random_intercept_sigma_raw(((M - 1) * logical_gt(N_random_intercepts, 0)));
        size_t random_intercept_sigma_raw_j_1_max__ = ((M - 1) * logical_gt(N_random_intercepts, 0));
        for (size_t j_1__ = 0; j_1__ < random_intercept_sigma_raw_j_1_max__; ++j_1__) {
            random_intercept_sigma_raw(j_1__) = vals_r__[pos__++];
        }
        try {
            writer__.row_vector_unconstrain(random_intercept_sigma_raw);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable random_intercept_sigma_raw: ") + e.what()), current_statement_begin__, prog_reader__());
        }
        current_statement_begin__ = 160;
        if (!(context__.contains_r("zero_random_intercept")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable zero_random_intercept missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("zero_random_intercept");
        pos__ = 0U;
        validate_non_negative_index("zero_random_intercept", "logical_gt(N_random_intercepts, 0)", logical_gt(N_random_intercepts, 0));
        context__.validate_dims("parameter initialization", "zero_random_intercept", "double", context__.to_vec(logical_gt(N_random_intercepts, 0)));
        std::vector<double> zero_random_intercept(logical_gt(N_random_intercepts, 0), double(0));
        size_t zero_random_intercept_k_0_max__ = logical_gt(N_random_intercepts, 0);
        for (size_t k_0__ = 0; k_0__ < zero_random_intercept_k_0_max__; ++k_0__) {
            zero_random_intercept[k_0__] = vals_r__[pos__++];
        }
        size_t zero_random_intercept_i_0_max__ = logical_gt(N_random_intercepts, 0);
        for (size_t i_0__ = 0; i_0__ < zero_random_intercept_i_0_max__; ++i_0__) {
            try {
                writer__.scalar_unconstrain(zero_random_intercept[i_0__]);
            } catch (const std::exception& e) {
                stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable zero_random_intercept: ") + e.what()), current_statement_begin__, prog_reader__());
            }
        }
        params_r__ = writer__.data_r();
        params_i__ = writer__.data_i();
    }
    void transform_inits(const stan::io::var_context& context,
                         Eigen::Matrix<double, Eigen::Dynamic, 1>& params_r,
                         std::ostream* pstream__) const {
      std::vector<double> params_r_vec;
      std::vector<int> params_i_vec;
      transform_inits(context, params_i_vec, params_r_vec, pstream__);
      params_r.resize(params_r_vec.size());
      for (int i = 0; i < params_r.size(); ++i)
        params_r(i) = params_r_vec[i];
    }
    template <bool propto__, bool jacobian__, typename T__>
    T__ log_prob(std::vector<T__>& params_r__,
                 std::vector<int>& params_i__,
                 std::ostream* pstream__ = 0) const {
        typedef T__ local_scalar_t__;
        local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // dummy to suppress unused var warning
        T__ lp__(0.0);
        stan::math::accumulator<T__> lp_accum__;
        try {
            stan::io::reader<local_scalar_t__> in__(params_r__, params_i__);
            // model parameters
            current_statement_begin__ = 147;
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, Eigen::Dynamic> beta_raw_raw;
            (void) beta_raw_raw;  // dummy to suppress unused var warning
            if (jacobian__)
                beta_raw_raw = in__.matrix_constrain(C, (M - 1), lp__);
            else
                beta_raw_raw = in__.matrix_constrain(C, (M - 1));
            current_statement_begin__ = 148;
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, Eigen::Dynamic> alpha;
            (void) alpha;  // dummy to suppress unused var warning
            if (jacobian__)
                alpha = in__.matrix_constrain(A, M, lp__);
            else
                alpha = in__.matrix_constrain(A, M);
            current_statement_begin__ = 150;
            std::vector<local_scalar_t__> prec_coeff;
            size_t prec_coeff_d_0_max__ = 2;
            prec_coeff.reserve(prec_coeff_d_0_max__);
            for (size_t d_0__ = 0; d_0__ < prec_coeff_d_0_max__; ++d_0__) {
                if (jacobian__)
                    prec_coeff.push_back(in__.scalar_constrain(lp__));
                else
                    prec_coeff.push_back(in__.scalar_constrain());
            }
            current_statement_begin__ = 151;
            local_scalar_t__ prec_sd;
            (void) prec_sd;  // dummy to suppress unused var warning
            if (jacobian__)
                prec_sd = in__.scalar_lb_constrain(0, lp__);
            else
                prec_sd = in__.scalar_lb_constrain(0);
            current_statement_begin__ = 152;
            local_scalar_t__ mix_p;
            (void) mix_p;  // dummy to suppress unused var warning
            if (jacobian__)
                mix_p = in__.scalar_lub_constrain(0, 1, lp__);
            else
                mix_p = in__.scalar_lub_constrain(0, 1);
            current_statement_begin__ = 154;
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, Eigen::Dynamic> random_intercept_raw;
            (void) random_intercept_raw;  // dummy to suppress unused var warning
            if (jacobian__)
                random_intercept_raw = in__.matrix_constrain((N_random_intercepts * logical_gt(N_random_intercepts, 0)), (M - 1), lp__);
            else
                random_intercept_raw = in__.matrix_constrain((N_random_intercepts * logical_gt(N_random_intercepts, 0)), (M - 1));
            current_statement_begin__ = 156;
            std::vector<local_scalar_t__> random_intercept_sigma_mu;
            size_t random_intercept_sigma_mu_d_0_max__ = logical_gt(N_random_intercepts, 0);
            random_intercept_sigma_mu.reserve(random_intercept_sigma_mu_d_0_max__);
            for (size_t d_0__ = 0; d_0__ < random_intercept_sigma_mu_d_0_max__; ++d_0__) {
                if (jacobian__)
                    random_intercept_sigma_mu.push_back(in__.scalar_constrain(lp__));
                else
                    random_intercept_sigma_mu.push_back(in__.scalar_constrain());
            }
            current_statement_begin__ = 157;
            std::vector<local_scalar_t__> random_intercept_sigma_sigma;
            size_t random_intercept_sigma_sigma_d_0_max__ = logical_gt(N_random_intercepts, 0);
            random_intercept_sigma_sigma.reserve(random_intercept_sigma_sigma_d_0_max__);
            for (size_t d_0__ = 0; d_0__ < random_intercept_sigma_sigma_d_0_max__; ++d_0__) {
                if (jacobian__)
                    random_intercept_sigma_sigma.push_back(in__.scalar_constrain(lp__));
                else
                    random_intercept_sigma_sigma.push_back(in__.scalar_constrain());
            }
            current_statement_begin__ = 158;
            Eigen::Matrix<local_scalar_t__, 1, Eigen::Dynamic> random_intercept_sigma_raw;
            (void) random_intercept_sigma_raw;  // dummy to suppress unused var warning
            if (jacobian__)
                random_intercept_sigma_raw = in__.row_vector_constrain(((M - 1) * logical_gt(N_random_intercepts, 0)), lp__);
            else
                random_intercept_sigma_raw = in__.row_vector_constrain(((M - 1) * logical_gt(N_random_intercepts, 0)));
            current_statement_begin__ = 160;
            std::vector<local_scalar_t__> zero_random_intercept;
            size_t zero_random_intercept_d_0_max__ = logical_gt(N_random_intercepts, 0);
            zero_random_intercept.reserve(zero_random_intercept_d_0_max__);
            for (size_t d_0__ = 0; d_0__ < zero_random_intercept_d_0_max__; ++d_0__) {
                if (jacobian__)
                    zero_random_intercept.push_back(in__.scalar_constrain(lp__));
                else
                    zero_random_intercept.push_back(in__.scalar_constrain());
            }
            // transformed parameters
            current_statement_begin__ = 165;
            validate_non_negative_index("beta_raw", "C", C);
            validate_non_negative_index("beta_raw", "M", M);
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, Eigen::Dynamic> beta_raw(C, M);
            stan::math::initialize(beta_raw, DUMMY_VAR__);
            stan::math::fill(beta_raw, DUMMY_VAR__);
            current_statement_begin__ = 166;
            validate_non_negative_index("precision", "M", M);
            validate_non_negative_index("precision", "N", N);
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, Eigen::Dynamic> precision(M, N);
            stan::math::initialize(precision, DUMMY_VAR__);
            stan::math::fill(precision, DUMMY_VAR__);
            stan::math::assign(precision,transpose(multiply(Xa, alpha)));
            current_statement_begin__ = 167;
            validate_non_negative_index("beta", "C", C);
            validate_non_negative_index("beta", "M", M);
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, Eigen::Dynamic> beta(C, M);
            stan::math::initialize(beta, DUMMY_VAR__);
            stan::math::fill(beta, DUMMY_VAR__);
            current_statement_begin__ = 170;
            validate_non_negative_index("random_intercept_minus_sum", "N_minus_sum", N_minus_sum);
            validate_non_negative_index("random_intercept_minus_sum", "(M - 1)", (M - 1));
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, Eigen::Dynamic> random_intercept_minus_sum(N_minus_sum, (M - 1));
            stan::math::initialize(random_intercept_minus_sum, DUMMY_VAR__);
            stan::math::fill(random_intercept_minus_sum, DUMMY_VAR__);
            current_statement_begin__ = 171;
            validate_non_negative_index("random_intercept_sigma", "(M - 1)", (M - 1));
            Eigen::Matrix<local_scalar_t__, 1, Eigen::Dynamic> random_intercept_sigma((M - 1));
            stan::math::initialize(random_intercept_sigma, DUMMY_VAR__);
            stan::math::fill(random_intercept_sigma, DUMMY_VAR__);
            current_statement_begin__ = 172;
            validate_non_negative_index("beta_random_intercept_raw", "N_grouping", N_grouping);
            validate_non_negative_index("beta_random_intercept_raw", "(M - 1)", (M - 1));
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, Eigen::Dynamic> beta_random_intercept_raw(N_grouping, (M - 1));
            stan::math::initialize(beta_random_intercept_raw, DUMMY_VAR__);
            stan::math::fill(beta_random_intercept_raw, DUMMY_VAR__);
            current_statement_begin__ = 175;
            validate_non_negative_index("mu", "M", M);
            validate_non_negative_index("mu", "N", N);
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, Eigen::Dynamic> mu(M, N);
            stan::math::initialize(mu, DUMMY_VAR__);
            stan::math::fill(mu, DUMMY_VAR__);
            current_statement_begin__ = 178;
            validate_non_negative_index("mu_array", "(N * M)", (N * M));
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, 1> mu_array((N * M));
            stan::math::initialize(mu_array, DUMMY_VAR__);
            stan::math::fill(mu_array, DUMMY_VAR__);
            current_statement_begin__ = 179;
            validate_non_negative_index("precision_array", "(N * M)", (N * M));
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, 1> precision_array((N * M));
            stan::math::initialize(precision_array, DUMMY_VAR__);
            stan::math::fill(precision_array, DUMMY_VAR__);
            // transformed parameters block statements
            current_statement_begin__ = 181;
            for (int c = 1; c <= C; ++c) {
                current_statement_begin__ = 181;
                stan::model::assign(beta_raw, 
                            stan::model::cons_list(stan::model::index_uni(c), stan::model::cons_list(stan::model::index_omni(), stan::model::nil_index_list())), 
                            sum_to_zero_QR(stan::model::rvalue(beta_raw_raw, stan::model::cons_list(stan::model::index_uni(c), stan::model::cons_list(stan::model::index_omni(), stan::model::nil_index_list())), "beta_raw_raw"), Q_r, pstream__), 
                            "assigning variable beta_raw");
            }
            current_statement_begin__ = 182;
            stan::math::assign(beta, multiply(R_ast_inverse, beta_raw));
            current_statement_begin__ = 185;
            stan::math::assign(mu, transpose(multiply(Q_ast, beta_raw)));
            current_statement_begin__ = 188;
            if (as_bool(logical_gt(N_random_intercepts, 0))) {
                current_statement_begin__ = 189;
                stan::math::assign(random_intercept_sigma, add(get_base1(random_intercept_sigma_mu, 1, "random_intercept_sigma_mu", 1), multiply(get_base1(random_intercept_sigma_sigma, 1, "random_intercept_sigma_sigma", 1), random_intercept_sigma_raw)));
                current_statement_begin__ = 191;
                for (int a = 1; a <= N_minus_sum; ++a) {
                    {
                    current_statement_begin__ = 193;
                    validate_non_negative_index("temp_random_intercept", "(M - 1)", (M - 1));
                    Eigen::Matrix<local_scalar_t__, 1, Eigen::Dynamic> temp_random_intercept((M - 1));
                    stan::math::initialize(temp_random_intercept, DUMMY_VAR__);
                    stan::math::fill(temp_random_intercept, DUMMY_VAR__);
                    stan::math::assign(temp_random_intercept,rep_row_vector(0, (M - 1)));
                    current_statement_begin__ = 195;
                    for (int n = 1; n <= N_random_intercepts; ++n) {
                        current_statement_begin__ = 196;
                        if (as_bool(logical_eq(get_base1(get_base1(paring_cov_random_intercept, n, "paring_cov_random_intercept", 1), 1, "paring_cov_random_intercept", 2), a))) {
                            current_statement_begin__ = 197;
                            stan::math::assign(temp_random_intercept, add(temp_random_intercept, get_base1(random_intercept_raw, n, "random_intercept_raw", 1)));
                        }
                    }
                    current_statement_begin__ = 200;
                    stan::model::assign(random_intercept_minus_sum, 
                                stan::model::cons_list(stan::model::index_uni(a), stan::model::nil_index_list()), 
                                multiply(temp_random_intercept, -(1)), 
                                "assigning variable random_intercept_minus_sum");
                    }
                }
                current_statement_begin__ = 203;
                for (int n = 1; n <= N_grouping; ++n) {
                    current_statement_begin__ = 204;
                    if (as_bool(logical_gt(get_base1(get_base1(idx_group_random_intercepts, n, "idx_group_random_intercepts", 1), 2, "idx_group_random_intercepts", 2), 0))) {
                        current_statement_begin__ = 205;
                        stan::model::assign(beta_random_intercept_raw, 
                                    stan::model::cons_list(stan::model::index_uni(get_base1(get_base1(idx_group_random_intercepts, n, "idx_group_random_intercepts", 1), 1, "idx_group_random_intercepts", 2)), stan::model::nil_index_list()), 
                                    elt_multiply(get_base1(random_intercept_raw, get_base1(get_base1(idx_group_random_intercepts, n, "idx_group_random_intercepts", 1), 2, "idx_group_random_intercepts", 2), "random_intercept_raw", 1), stan::math::exp(divide(random_intercept_sigma, 3.0))), 
                                    "assigning variable beta_random_intercept_raw");
                    } else if (as_bool(logical_lt(get_base1(get_base1(idx_group_random_intercepts, n, "idx_group_random_intercepts", 1), 2, "idx_group_random_intercepts", 2), 0))) {
                        current_statement_begin__ = 207;
                        stan::model::assign(beta_random_intercept_raw, 
                                    stan::model::cons_list(stan::model::index_uni(get_base1(get_base1(idx_group_random_intercepts, n, "idx_group_random_intercepts", 1), 1, "idx_group_random_intercepts", 2)), stan::model::nil_index_list()), 
                                    elt_multiply(get_base1(random_intercept_minus_sum, -(get_base1(get_base1(idx_group_random_intercepts, n, "idx_group_random_intercepts", 1), 2, "idx_group_random_intercepts", 2)), "random_intercept_minus_sum", 1), stan::math::exp(divide(random_intercept_sigma, 3.0))), 
                                    "assigning variable beta_random_intercept_raw");
                    } else {
                        current_statement_begin__ = 209;
                        stan::model::assign(beta_random_intercept_raw, 
                                    stan::model::cons_list(stan::model::index_uni(get_base1(get_base1(idx_group_random_intercepts, n, "idx_group_random_intercepts", 1), 1, "idx_group_random_intercepts", 2)), stan::model::nil_index_list()), 
                                    rep_row_vector((get_base1(zero_random_intercept, logical_gt(N_random_intercepts, 0), "zero_random_intercept", 1) * stan::math::exp((get_base1(random_intercept_sigma_mu, 1, "random_intercept_sigma_mu", 1) / 3.0))), (M - 1)), 
                                    "assigning variable beta_random_intercept_raw");
                    }
                }
                current_statement_begin__ = 213;
                stan::math::assign(mu, add(mu, append_row(transpose(multiply(X_random_intercept, beta_random_intercept_raw)), rep_row_vector(0, N))));
            }
            current_statement_begin__ = 217;
            for (int n = 1; n <= N; ++n) {
                current_statement_begin__ = 217;
                stan::model::assign(mu, 
                            stan::model::cons_list(stan::model::index_omni(), stan::model::cons_list(stan::model::index_uni(n), stan::model::nil_index_list())), 
                            stan::model::deep_copy(softmax(stan::model::rvalue(mu, stan::model::cons_list(stan::model::index_omni(), stan::model::cons_list(stan::model::index_uni(n), stan::model::nil_index_list())), "mu"))), 
                            "assigning variable mu");
            }
            current_statement_begin__ = 220;
            stan::math::assign(mu_array, to_vector(mu));
            current_statement_begin__ = 221;
            stan::math::assign(precision_array, to_vector(stan::math::exp(precision)));
            // validate transformed parameters
            const char* function__ = "validate transformed params";
            (void) function__;  // dummy to suppress unused var warning
            current_statement_begin__ = 165;
            size_t beta_raw_j_1_max__ = C;
            size_t beta_raw_j_2_max__ = M;
            for (size_t j_1__ = 0; j_1__ < beta_raw_j_1_max__; ++j_1__) {
                for (size_t j_2__ = 0; j_2__ < beta_raw_j_2_max__; ++j_2__) {
                    if (stan::math::is_uninitialized(beta_raw(j_1__, j_2__))) {
                        std::stringstream msg__;
                        msg__ << "Undefined transformed parameter: beta_raw" << "(" << j_1__ << ", " << j_2__ << ")";
                        stan::lang::rethrow_located(std::runtime_error(std::string("Error initializing variable beta_raw: ") + msg__.str()), current_statement_begin__, prog_reader__());
                    }
                }
            }
            current_statement_begin__ = 166;
            size_t precision_j_1_max__ = M;
            size_t precision_j_2_max__ = N;
            for (size_t j_1__ = 0; j_1__ < precision_j_1_max__; ++j_1__) {
                for (size_t j_2__ = 0; j_2__ < precision_j_2_max__; ++j_2__) {
                    if (stan::math::is_uninitialized(precision(j_1__, j_2__))) {
                        std::stringstream msg__;
                        msg__ << "Undefined transformed parameter: precision" << "(" << j_1__ << ", " << j_2__ << ")";
                        stan::lang::rethrow_located(std::runtime_error(std::string("Error initializing variable precision: ") + msg__.str()), current_statement_begin__, prog_reader__());
                    }
                }
            }
            current_statement_begin__ = 167;
            size_t beta_j_1_max__ = C;
            size_t beta_j_2_max__ = M;
            for (size_t j_1__ = 0; j_1__ < beta_j_1_max__; ++j_1__) {
                for (size_t j_2__ = 0; j_2__ < beta_j_2_max__; ++j_2__) {
                    if (stan::math::is_uninitialized(beta(j_1__, j_2__))) {
                        std::stringstream msg__;
                        msg__ << "Undefined transformed parameter: beta" << "(" << j_1__ << ", " << j_2__ << ")";
                        stan::lang::rethrow_located(std::runtime_error(std::string("Error initializing variable beta: ") + msg__.str()), current_statement_begin__, prog_reader__());
                    }
                }
            }
            current_statement_begin__ = 170;
            size_t random_intercept_minus_sum_j_1_max__ = N_minus_sum;
            size_t random_intercept_minus_sum_j_2_max__ = (M - 1);
            for (size_t j_1__ = 0; j_1__ < random_intercept_minus_sum_j_1_max__; ++j_1__) {
                for (size_t j_2__ = 0; j_2__ < random_intercept_minus_sum_j_2_max__; ++j_2__) {
                    if (stan::math::is_uninitialized(random_intercept_minus_sum(j_1__, j_2__))) {
                        std::stringstream msg__;
                        msg__ << "Undefined transformed parameter: random_intercept_minus_sum" << "(" << j_1__ << ", " << j_2__ << ")";
                        stan::lang::rethrow_located(std::runtime_error(std::string("Error initializing variable random_intercept_minus_sum: ") + msg__.str()), current_statement_begin__, prog_reader__());
                    }
                }
            }
            current_statement_begin__ = 171;
            size_t random_intercept_sigma_j_1_max__ = (M - 1);
            for (size_t j_1__ = 0; j_1__ < random_intercept_sigma_j_1_max__; ++j_1__) {
                if (stan::math::is_uninitialized(random_intercept_sigma(j_1__))) {
                    std::stringstream msg__;
                    msg__ << "Undefined transformed parameter: random_intercept_sigma" << "(" << j_1__ << ")";
                    stan::lang::rethrow_located(std::runtime_error(std::string("Error initializing variable random_intercept_sigma: ") + msg__.str()), current_statement_begin__, prog_reader__());
                }
            }
            current_statement_begin__ = 172;
            size_t beta_random_intercept_raw_j_1_max__ = N_grouping;
            size_t beta_random_intercept_raw_j_2_max__ = (M - 1);
            for (size_t j_1__ = 0; j_1__ < beta_random_intercept_raw_j_1_max__; ++j_1__) {
                for (size_t j_2__ = 0; j_2__ < beta_random_intercept_raw_j_2_max__; ++j_2__) {
                    if (stan::math::is_uninitialized(beta_random_intercept_raw(j_1__, j_2__))) {
                        std::stringstream msg__;
                        msg__ << "Undefined transformed parameter: beta_random_intercept_raw" << "(" << j_1__ << ", " << j_2__ << ")";
                        stan::lang::rethrow_located(std::runtime_error(std::string("Error initializing variable beta_random_intercept_raw: ") + msg__.str()), current_statement_begin__, prog_reader__());
                    }
                }
            }
            current_statement_begin__ = 175;
            size_t mu_j_1_max__ = M;
            size_t mu_j_2_max__ = N;
            for (size_t j_1__ = 0; j_1__ < mu_j_1_max__; ++j_1__) {
                for (size_t j_2__ = 0; j_2__ < mu_j_2_max__; ++j_2__) {
                    if (stan::math::is_uninitialized(mu(j_1__, j_2__))) {
                        std::stringstream msg__;
                        msg__ << "Undefined transformed parameter: mu" << "(" << j_1__ << ", " << j_2__ << ")";
                        stan::lang::rethrow_located(std::runtime_error(std::string("Error initializing variable mu: ") + msg__.str()), current_statement_begin__, prog_reader__());
                    }
                }
            }
            current_statement_begin__ = 178;
            size_t mu_array_j_1_max__ = (N * M);
            for (size_t j_1__ = 0; j_1__ < mu_array_j_1_max__; ++j_1__) {
                if (stan::math::is_uninitialized(mu_array(j_1__))) {
                    std::stringstream msg__;
                    msg__ << "Undefined transformed parameter: mu_array" << "(" << j_1__ << ")";
                    stan::lang::rethrow_located(std::runtime_error(std::string("Error initializing variable mu_array: ") + msg__.str()), current_statement_begin__, prog_reader__());
                }
            }
            current_statement_begin__ = 179;
            size_t precision_array_j_1_max__ = (N * M);
            for (size_t j_1__ = 0; j_1__ < precision_array_j_1_max__; ++j_1__) {
                if (stan::math::is_uninitialized(precision_array(j_1__))) {
                    std::stringstream msg__;
                    msg__ << "Undefined transformed parameter: precision_array" << "(" << j_1__ << ")";
                    stan::lang::rethrow_located(std::runtime_error(std::string("Error initializing variable precision_array: ") + msg__.str()), current_statement_begin__, prog_reader__());
                }
            }
            // model body
            current_statement_begin__ = 227;
            if (as_bool(logical_eq(use_data, 1))) {
                current_statement_begin__ = 228;
                lp_accum__.add(beta_binomial_log(stan::model::rvalue(y_array, stan::model::cons_list(stan::model::index_multi(truncation_not_idx), stan::model::nil_index_list()), "y_array"), stan::model::rvalue(exposure_array, stan::model::cons_list(stan::model::index_multi(truncation_not_idx), stan::model::nil_index_list()), "exposure_array"), elt_multiply(stan::model::rvalue(mu_array, stan::model::cons_list(stan::model::index_multi(truncation_not_idx), stan::model::nil_index_list()), "mu_array"), stan::model::rvalue(precision_array, stan::model::cons_list(stan::model::index_multi(truncation_not_idx), stan::model::nil_index_list()), "precision_array")), elt_multiply(subtract(1.0, stan::model::rvalue(mu_array, stan::model::cons_list(stan::model::index_multi(truncation_not_idx), stan::model::nil_index_list()), "mu_array")), stan::model::rvalue(precision_array, stan::model::cons_list(stan::model::index_multi(truncation_not_idx), stan::model::nil_index_list()), "precision_array"))));
            }
            current_statement_begin__ = 237;
            if (as_bool(logical_eq(exclude_priors, 0))) {
                current_statement_begin__ = 239;
                if (as_bool((primitive_value(intercept_in_design) || primitive_value(logical_gt(A, 1))))) {
                    current_statement_begin__ = 241;
                    for (int a = 1; a <= A_intercept_columns; ++a) {
                        current_statement_begin__ = 242;
                        lp_accum__.add(abundance_variability_regression(get_base1(alpha, a, "alpha", 1), get_base1(beta, a, "beta", 1), prec_coeff, prec_sd, bimodal_mean_variability_association, mix_p, pstream__));
                    }
                    current_statement_begin__ = 251;
                    if (as_bool(logical_gt(A, A_intercept_columns))) {
                        current_statement_begin__ = 251;
                        for (int a = (A_intercept_columns + 1); a <= A; ++a) {
                            current_statement_begin__ = 251;
                            lp_accum__.add(normal_log<propto__>(get_base1(alpha, a, "alpha", 1), multiply(get_base1(beta, a, "beta", 1), get_base1(prec_coeff, 2, "prec_coeff", 1)), 2));
                        }
                    }
                } else {
                    current_statement_begin__ = 256;
                    lp_accum__.add(abundance_variability_regression(get_base1(alpha, 1, "alpha", 1), average_by_col(stan::model::rvalue(beta, stan::model::cons_list(stan::model::index_min_max(1, A_intercept_columns), stan::model::cons_list(stan::model::index_omni(), stan::model::nil_index_list())), "beta"), pstream__), prec_coeff, prec_sd, bimodal_mean_variability_association, mix_p, pstream__));
                }
            } else {
                current_statement_begin__ = 269;
                if (as_bool((primitive_value(intercept_in_design) || primitive_value(logical_gt(A, 1))))) {
                    current_statement_begin__ = 270;
                    for (int a = 1; a <= A_intercept_columns; ++a) {
                        current_statement_begin__ = 270;
                        lp_accum__.add(normal_log<propto__>(get_base1(alpha, a, "alpha", 1), get_base1(prior_prec_slope, 1, "prior_prec_slope", 1), get_base1(prior_prec_sd, 1, "prior_prec_sd", 1)));
                    }
                    current_statement_begin__ = 271;
                    if (as_bool(logical_gt(A, A_intercept_columns))) {
                        current_statement_begin__ = 271;
                        for (int a = (A_intercept_columns + 1); a <= A; ++a) {
                            current_statement_begin__ = 271;
                            lp_accum__.add(normal_log<propto__>(to_vector(get_base1(alpha, a, "alpha", 1)), 0, 2));
                        }
                    }
                } else {
                    current_statement_begin__ = 275;
                    lp_accum__.add(normal_log<propto__>(get_base1(alpha, 1, "alpha", 1), get_base1(prior_prec_slope, 1, "prior_prec_slope", 1), get_base1(prior_prec_sd, 1, "prior_prec_sd", 1)));
                }
            }
            current_statement_begin__ = 280;
            lp_accum__.add(normal_log<propto__>(get_base1(beta_raw_raw, 1, "beta_raw_raw", 1), 0, x_raw_sigma));
            current_statement_begin__ = 281;
            if (as_bool(logical_gt(C, 1))) {
                current_statement_begin__ = 281;
                for (int c = 2; c <= C; ++c) {
                    current_statement_begin__ = 281;
                    lp_accum__.add(normal_log<propto__>(to_vector(get_base1(beta_raw_raw, c, "beta_raw_raw", 1)), 0, x_raw_sigma));
                }
            }
            current_statement_begin__ = 284;
            lp_accum__.add(beta_log<propto__>(mix_p, 1, 5));
            current_statement_begin__ = 285;
            lp_accum__.add(normal_log<propto__>(get_base1(prec_coeff, 1, "prec_coeff", 1), get_base1(prior_prec_intercept, 1, "prior_prec_intercept", 1), get_base1(prior_prec_intercept, 2, "prior_prec_intercept", 1)));
            current_statement_begin__ = 286;
            lp_accum__.add(normal_log<propto__>(get_base1(prec_coeff, 2, "prec_coeff", 1), get_base1(prior_prec_slope, 1, "prior_prec_slope", 1), get_base1(prior_prec_slope, 2, "prior_prec_slope", 1)));
            current_statement_begin__ = 287;
            lp_accum__.add(gamma_log<propto__>(prec_sd, get_base1(prior_prec_sd, 1, "prior_prec_sd", 1), get_base1(prior_prec_sd, 2, "prior_prec_sd", 1)));
            current_statement_begin__ = 290;
            if (as_bool(logical_gt(N_random_intercepts, 0))) {
                current_statement_begin__ = 291;
                for (int m = 1; m <= (M - 1); ++m) {
                    current_statement_begin__ = 291;
                    lp_accum__.add(std_normal_log<propto__>(stan::model::rvalue(random_intercept_raw, stan::model::cons_list(stan::model::index_omni(), stan::model::cons_list(stan::model::index_uni(m), stan::model::nil_index_list())), "random_intercept_raw")));
                }
                current_statement_begin__ = 292;
                lp_accum__.add(std_normal_log<propto__>(random_intercept_sigma_raw));
                current_statement_begin__ = 293;
                lp_accum__.add(std_normal_log<propto__>(random_intercept_sigma_mu));
                current_statement_begin__ = 294;
                lp_accum__.add(std_normal_log<propto__>(random_intercept_sigma_sigma));
                current_statement_begin__ = 296;
                lp_accum__.add(std_normal_log<propto__>(zero_random_intercept));
            }
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(e, current_statement_begin__, prog_reader__());
            // Next line prevents compiler griping about no return
            throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
        }
        lp_accum__.add(lp__);
        return lp_accum__.sum();
    } // log_prob()
    template <bool propto, bool jacobian, typename T_>
    T_ log_prob(Eigen::Matrix<T_,Eigen::Dynamic,1>& params_r,
               std::ostream* pstream = 0) const {
      std::vector<T_> vec_params_r;
      vec_params_r.reserve(params_r.size());
      for (int i = 0; i < params_r.size(); ++i)
        vec_params_r.push_back(params_r(i));
      std::vector<int> vec_params_i;
      return log_prob<propto,jacobian,T_>(vec_params_r, vec_params_i, pstream);
    }
    void get_param_names(std::vector<std::string>& names__) const {
        names__.resize(0);
        names__.push_back("beta_raw_raw");
        names__.push_back("alpha");
        names__.push_back("prec_coeff");
        names__.push_back("prec_sd");
        names__.push_back("mix_p");
        names__.push_back("random_intercept_raw");
        names__.push_back("random_intercept_sigma_mu");
        names__.push_back("random_intercept_sigma_sigma");
        names__.push_back("random_intercept_sigma_raw");
        names__.push_back("zero_random_intercept");
        names__.push_back("beta_raw");
        names__.push_back("precision");
        names__.push_back("beta");
        names__.push_back("random_intercept_minus_sum");
        names__.push_back("random_intercept_sigma");
        names__.push_back("beta_random_intercept_raw");
        names__.push_back("mu");
        names__.push_back("mu_array");
        names__.push_back("precision_array");
        names__.push_back("alpha_normalised");
        names__.push_back("beta_random_intercept");
        names__.push_back("log_lik");
    }
    void get_dims(std::vector<std::vector<size_t> >& dimss__) const {
        dimss__.resize(0);
        std::vector<size_t> dims__;
        dims__.resize(0);
        dims__.push_back(C);
        dims__.push_back((M - 1));
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(A);
        dims__.push_back(M);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(2);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back((N_random_intercepts * logical_gt(N_random_intercepts, 0)));
        dims__.push_back((M - 1));
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(logical_gt(N_random_intercepts, 0));
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(logical_gt(N_random_intercepts, 0));
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(((M - 1) * logical_gt(N_random_intercepts, 0)));
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(logical_gt(N_random_intercepts, 0));
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(C);
        dims__.push_back(M);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(M);
        dims__.push_back(N);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(C);
        dims__.push_back(M);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(N_minus_sum);
        dims__.push_back((M - 1));
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back((M - 1));
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(N_grouping);
        dims__.push_back((M - 1));
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(M);
        dims__.push_back(N);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back((N * M));
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back((N * M));
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(A);
        dims__.push_back(M);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(N_grouping_WINDOWS_BUG_FIX);
        dims__.push_back(M);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(TNS);
        dimss__.push_back(dims__);
    }
    template <typename RNG>
    void write_array(RNG& base_rng__,
                     std::vector<double>& params_r__,
                     std::vector<int>& params_i__,
                     std::vector<double>& vars__,
                     bool include_tparams__ = true,
                     bool include_gqs__ = true,
                     std::ostream* pstream__ = 0) const {
        typedef double local_scalar_t__;
        vars__.resize(0);
        stan::io::reader<local_scalar_t__> in__(params_r__, params_i__);
        static const char* function__ = "model_glm_multi_beta_binomial_namespace::write_array";
        (void) function__;  // dummy to suppress unused var warning
        // read-transform, write parameters
        Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> beta_raw_raw = in__.matrix_constrain(C, (M - 1));
        size_t beta_raw_raw_j_2_max__ = (M - 1);
        size_t beta_raw_raw_j_1_max__ = C;
        for (size_t j_2__ = 0; j_2__ < beta_raw_raw_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < beta_raw_raw_j_1_max__; ++j_1__) {
                vars__.push_back(beta_raw_raw(j_1__, j_2__));
            }
        }
        Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> alpha = in__.matrix_constrain(A, M);
        size_t alpha_j_2_max__ = M;
        size_t alpha_j_1_max__ = A;
        for (size_t j_2__ = 0; j_2__ < alpha_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < alpha_j_1_max__; ++j_1__) {
                vars__.push_back(alpha(j_1__, j_2__));
            }
        }
        std::vector<double> prec_coeff;
        size_t prec_coeff_d_0_max__ = 2;
        prec_coeff.reserve(prec_coeff_d_0_max__);
        for (size_t d_0__ = 0; d_0__ < prec_coeff_d_0_max__; ++d_0__) {
            prec_coeff.push_back(in__.scalar_constrain());
        }
        size_t prec_coeff_k_0_max__ = 2;
        for (size_t k_0__ = 0; k_0__ < prec_coeff_k_0_max__; ++k_0__) {
            vars__.push_back(prec_coeff[k_0__]);
        }
        double prec_sd = in__.scalar_lb_constrain(0);
        vars__.push_back(prec_sd);
        double mix_p = in__.scalar_lub_constrain(0, 1);
        vars__.push_back(mix_p);
        Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> random_intercept_raw = in__.matrix_constrain((N_random_intercepts * logical_gt(N_random_intercepts, 0)), (M - 1));
        size_t random_intercept_raw_j_2_max__ = (M - 1);
        size_t random_intercept_raw_j_1_max__ = (N_random_intercepts * logical_gt(N_random_intercepts, 0));
        for (size_t j_2__ = 0; j_2__ < random_intercept_raw_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < random_intercept_raw_j_1_max__; ++j_1__) {
                vars__.push_back(random_intercept_raw(j_1__, j_2__));
            }
        }
        std::vector<double> random_intercept_sigma_mu;
        size_t random_intercept_sigma_mu_d_0_max__ = logical_gt(N_random_intercepts, 0);
        random_intercept_sigma_mu.reserve(random_intercept_sigma_mu_d_0_max__);
        for (size_t d_0__ = 0; d_0__ < random_intercept_sigma_mu_d_0_max__; ++d_0__) {
            random_intercept_sigma_mu.push_back(in__.scalar_constrain());
        }
        size_t random_intercept_sigma_mu_k_0_max__ = logical_gt(N_random_intercepts, 0);
        for (size_t k_0__ = 0; k_0__ < random_intercept_sigma_mu_k_0_max__; ++k_0__) {
            vars__.push_back(random_intercept_sigma_mu[k_0__]);
        }
        std::vector<double> random_intercept_sigma_sigma;
        size_t random_intercept_sigma_sigma_d_0_max__ = logical_gt(N_random_intercepts, 0);
        random_intercept_sigma_sigma.reserve(random_intercept_sigma_sigma_d_0_max__);
        for (size_t d_0__ = 0; d_0__ < random_intercept_sigma_sigma_d_0_max__; ++d_0__) {
            random_intercept_sigma_sigma.push_back(in__.scalar_constrain());
        }
        size_t random_intercept_sigma_sigma_k_0_max__ = logical_gt(N_random_intercepts, 0);
        for (size_t k_0__ = 0; k_0__ < random_intercept_sigma_sigma_k_0_max__; ++k_0__) {
            vars__.push_back(random_intercept_sigma_sigma[k_0__]);
        }
        Eigen::Matrix<double, 1, Eigen::Dynamic> random_intercept_sigma_raw = in__.row_vector_constrain(((M - 1) * logical_gt(N_random_intercepts, 0)));
        size_t random_intercept_sigma_raw_j_1_max__ = ((M - 1) * logical_gt(N_random_intercepts, 0));
        for (size_t j_1__ = 0; j_1__ < random_intercept_sigma_raw_j_1_max__; ++j_1__) {
            vars__.push_back(random_intercept_sigma_raw(j_1__));
        }
        std::vector<double> zero_random_intercept;
        size_t zero_random_intercept_d_0_max__ = logical_gt(N_random_intercepts, 0);
        zero_random_intercept.reserve(zero_random_intercept_d_0_max__);
        for (size_t d_0__ = 0; d_0__ < zero_random_intercept_d_0_max__; ++d_0__) {
            zero_random_intercept.push_back(in__.scalar_constrain());
        }
        size_t zero_random_intercept_k_0_max__ = logical_gt(N_random_intercepts, 0);
        for (size_t k_0__ = 0; k_0__ < zero_random_intercept_k_0_max__; ++k_0__) {
            vars__.push_back(zero_random_intercept[k_0__]);
        }
        double lp__ = 0.0;
        (void) lp__;  // dummy to suppress unused var warning
        stan::math::accumulator<double> lp_accum__;
        local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // suppress unused var warning
        if (!include_tparams__ && !include_gqs__) return;
        try {
            // declare and define transformed parameters
            current_statement_begin__ = 165;
            validate_non_negative_index("beta_raw", "C", C);
            validate_non_negative_index("beta_raw", "M", M);
            Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> beta_raw(C, M);
            stan::math::initialize(beta_raw, DUMMY_VAR__);
            stan::math::fill(beta_raw, DUMMY_VAR__);
            current_statement_begin__ = 166;
            validate_non_negative_index("precision", "M", M);
            validate_non_negative_index("precision", "N", N);
            Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> precision(M, N);
            stan::math::initialize(precision, DUMMY_VAR__);
            stan::math::fill(precision, DUMMY_VAR__);
            stan::math::assign(precision,transpose(multiply(Xa, alpha)));
            current_statement_begin__ = 167;
            validate_non_negative_index("beta", "C", C);
            validate_non_negative_index("beta", "M", M);
            Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> beta(C, M);
            stan::math::initialize(beta, DUMMY_VAR__);
            stan::math::fill(beta, DUMMY_VAR__);
            current_statement_begin__ = 170;
            validate_non_negative_index("random_intercept_minus_sum", "N_minus_sum", N_minus_sum);
            validate_non_negative_index("random_intercept_minus_sum", "(M - 1)", (M - 1));
            Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> random_intercept_minus_sum(N_minus_sum, (M - 1));
            stan::math::initialize(random_intercept_minus_sum, DUMMY_VAR__);
            stan::math::fill(random_intercept_minus_sum, DUMMY_VAR__);
            current_statement_begin__ = 171;
            validate_non_negative_index("random_intercept_sigma", "(M - 1)", (M - 1));
            Eigen::Matrix<double, 1, Eigen::Dynamic> random_intercept_sigma((M - 1));
            stan::math::initialize(random_intercept_sigma, DUMMY_VAR__);
            stan::math::fill(random_intercept_sigma, DUMMY_VAR__);
            current_statement_begin__ = 172;
            validate_non_negative_index("beta_random_intercept_raw", "N_grouping", N_grouping);
            validate_non_negative_index("beta_random_intercept_raw", "(M - 1)", (M - 1));
            Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> beta_random_intercept_raw(N_grouping, (M - 1));
            stan::math::initialize(beta_random_intercept_raw, DUMMY_VAR__);
            stan::math::fill(beta_random_intercept_raw, DUMMY_VAR__);
            current_statement_begin__ = 175;
            validate_non_negative_index("mu", "M", M);
            validate_non_negative_index("mu", "N", N);
            Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> mu(M, N);
            stan::math::initialize(mu, DUMMY_VAR__);
            stan::math::fill(mu, DUMMY_VAR__);
            current_statement_begin__ = 178;
            validate_non_negative_index("mu_array", "(N * M)", (N * M));
            Eigen::Matrix<double, Eigen::Dynamic, 1> mu_array((N * M));
            stan::math::initialize(mu_array, DUMMY_VAR__);
            stan::math::fill(mu_array, DUMMY_VAR__);
            current_statement_begin__ = 179;
            validate_non_negative_index("precision_array", "(N * M)", (N * M));
            Eigen::Matrix<double, Eigen::Dynamic, 1> precision_array((N * M));
            stan::math::initialize(precision_array, DUMMY_VAR__);
            stan::math::fill(precision_array, DUMMY_VAR__);
            // do transformed parameters statements
            current_statement_begin__ = 181;
            for (int c = 1; c <= C; ++c) {
                current_statement_begin__ = 181;
                stan::model::assign(beta_raw, 
                            stan::model::cons_list(stan::model::index_uni(c), stan::model::cons_list(stan::model::index_omni(), stan::model::nil_index_list())), 
                            sum_to_zero_QR(stan::model::rvalue(beta_raw_raw, stan::model::cons_list(stan::model::index_uni(c), stan::model::cons_list(stan::model::index_omni(), stan::model::nil_index_list())), "beta_raw_raw"), Q_r, pstream__), 
                            "assigning variable beta_raw");
            }
            current_statement_begin__ = 182;
            stan::math::assign(beta, multiply(R_ast_inverse, beta_raw));
            current_statement_begin__ = 185;
            stan::math::assign(mu, transpose(multiply(Q_ast, beta_raw)));
            current_statement_begin__ = 188;
            if (as_bool(logical_gt(N_random_intercepts, 0))) {
                current_statement_begin__ = 189;
                stan::math::assign(random_intercept_sigma, add(get_base1(random_intercept_sigma_mu, 1, "random_intercept_sigma_mu", 1), multiply(get_base1(random_intercept_sigma_sigma, 1, "random_intercept_sigma_sigma", 1), random_intercept_sigma_raw)));
                current_statement_begin__ = 191;
                for (int a = 1; a <= N_minus_sum; ++a) {
                    {
                    current_statement_begin__ = 193;
                    validate_non_negative_index("temp_random_intercept", "(M - 1)", (M - 1));
                    Eigen::Matrix<local_scalar_t__, 1, Eigen::Dynamic> temp_random_intercept((M - 1));
                    stan::math::initialize(temp_random_intercept, DUMMY_VAR__);
                    stan::math::fill(temp_random_intercept, DUMMY_VAR__);
                    stan::math::assign(temp_random_intercept,rep_row_vector(0, (M - 1)));
                    current_statement_begin__ = 195;
                    for (int n = 1; n <= N_random_intercepts; ++n) {
                        current_statement_begin__ = 196;
                        if (as_bool(logical_eq(get_base1(get_base1(paring_cov_random_intercept, n, "paring_cov_random_intercept", 1), 1, "paring_cov_random_intercept", 2), a))) {
                            current_statement_begin__ = 197;
                            stan::math::assign(temp_random_intercept, add(temp_random_intercept, get_base1(random_intercept_raw, n, "random_intercept_raw", 1)));
                        }
                    }
                    current_statement_begin__ = 200;
                    stan::model::assign(random_intercept_minus_sum, 
                                stan::model::cons_list(stan::model::index_uni(a), stan::model::nil_index_list()), 
                                multiply(temp_random_intercept, -(1)), 
                                "assigning variable random_intercept_minus_sum");
                    }
                }
                current_statement_begin__ = 203;
                for (int n = 1; n <= N_grouping; ++n) {
                    current_statement_begin__ = 204;
                    if (as_bool(logical_gt(get_base1(get_base1(idx_group_random_intercepts, n, "idx_group_random_intercepts", 1), 2, "idx_group_random_intercepts", 2), 0))) {
                        current_statement_begin__ = 205;
                        stan::model::assign(beta_random_intercept_raw, 
                                    stan::model::cons_list(stan::model::index_uni(get_base1(get_base1(idx_group_random_intercepts, n, "idx_group_random_intercepts", 1), 1, "idx_group_random_intercepts", 2)), stan::model::nil_index_list()), 
                                    elt_multiply(get_base1(random_intercept_raw, get_base1(get_base1(idx_group_random_intercepts, n, "idx_group_random_intercepts", 1), 2, "idx_group_random_intercepts", 2), "random_intercept_raw", 1), stan::math::exp(divide(random_intercept_sigma, 3.0))), 
                                    "assigning variable beta_random_intercept_raw");
                    } else if (as_bool(logical_lt(get_base1(get_base1(idx_group_random_intercepts, n, "idx_group_random_intercepts", 1), 2, "idx_group_random_intercepts", 2), 0))) {
                        current_statement_begin__ = 207;
                        stan::model::assign(beta_random_intercept_raw, 
                                    stan::model::cons_list(stan::model::index_uni(get_base1(get_base1(idx_group_random_intercepts, n, "idx_group_random_intercepts", 1), 1, "idx_group_random_intercepts", 2)), stan::model::nil_index_list()), 
                                    elt_multiply(get_base1(random_intercept_minus_sum, -(get_base1(get_base1(idx_group_random_intercepts, n, "idx_group_random_intercepts", 1), 2, "idx_group_random_intercepts", 2)), "random_intercept_minus_sum", 1), stan::math::exp(divide(random_intercept_sigma, 3.0))), 
                                    "assigning variable beta_random_intercept_raw");
                    } else {
                        current_statement_begin__ = 209;
                        stan::model::assign(beta_random_intercept_raw, 
                                    stan::model::cons_list(stan::model::index_uni(get_base1(get_base1(idx_group_random_intercepts, n, "idx_group_random_intercepts", 1), 1, "idx_group_random_intercepts", 2)), stan::model::nil_index_list()), 
                                    rep_row_vector((get_base1(zero_random_intercept, logical_gt(N_random_intercepts, 0), "zero_random_intercept", 1) * stan::math::exp((get_base1(random_intercept_sigma_mu, 1, "random_intercept_sigma_mu", 1) / 3.0))), (M - 1)), 
                                    "assigning variable beta_random_intercept_raw");
                    }
                }
                current_statement_begin__ = 213;
                stan::math::assign(mu, add(mu, append_row(transpose(multiply(X_random_intercept, beta_random_intercept_raw)), rep_row_vector(0, N))));
            }
            current_statement_begin__ = 217;
            for (int n = 1; n <= N; ++n) {
                current_statement_begin__ = 217;
                stan::model::assign(mu, 
                            stan::model::cons_list(stan::model::index_omni(), stan::model::cons_list(stan::model::index_uni(n), stan::model::nil_index_list())), 
                            stan::model::deep_copy(softmax(stan::model::rvalue(mu, stan::model::cons_list(stan::model::index_omni(), stan::model::cons_list(stan::model::index_uni(n), stan::model::nil_index_list())), "mu"))), 
                            "assigning variable mu");
            }
            current_statement_begin__ = 220;
            stan::math::assign(mu_array, to_vector(mu));
            current_statement_begin__ = 221;
            stan::math::assign(precision_array, to_vector(stan::math::exp(precision)));
            if (!include_gqs__ && !include_tparams__) return;
            // validate transformed parameters
            const char* function__ = "validate transformed params";
            (void) function__;  // dummy to suppress unused var warning
            // write transformed parameters
            if (include_tparams__) {
                size_t beta_raw_j_2_max__ = M;
                size_t beta_raw_j_1_max__ = C;
                for (size_t j_2__ = 0; j_2__ < beta_raw_j_2_max__; ++j_2__) {
                    for (size_t j_1__ = 0; j_1__ < beta_raw_j_1_max__; ++j_1__) {
                        vars__.push_back(beta_raw(j_1__, j_2__));
                    }
                }
                size_t precision_j_2_max__ = N;
                size_t precision_j_1_max__ = M;
                for (size_t j_2__ = 0; j_2__ < precision_j_2_max__; ++j_2__) {
                    for (size_t j_1__ = 0; j_1__ < precision_j_1_max__; ++j_1__) {
                        vars__.push_back(precision(j_1__, j_2__));
                    }
                }
                size_t beta_j_2_max__ = M;
                size_t beta_j_1_max__ = C;
                for (size_t j_2__ = 0; j_2__ < beta_j_2_max__; ++j_2__) {
                    for (size_t j_1__ = 0; j_1__ < beta_j_1_max__; ++j_1__) {
                        vars__.push_back(beta(j_1__, j_2__));
                    }
                }
                size_t random_intercept_minus_sum_j_2_max__ = (M - 1);
                size_t random_intercept_minus_sum_j_1_max__ = N_minus_sum;
                for (size_t j_2__ = 0; j_2__ < random_intercept_minus_sum_j_2_max__; ++j_2__) {
                    for (size_t j_1__ = 0; j_1__ < random_intercept_minus_sum_j_1_max__; ++j_1__) {
                        vars__.push_back(random_intercept_minus_sum(j_1__, j_2__));
                    }
                }
                size_t random_intercept_sigma_j_1_max__ = (M - 1);
                for (size_t j_1__ = 0; j_1__ < random_intercept_sigma_j_1_max__; ++j_1__) {
                    vars__.push_back(random_intercept_sigma(j_1__));
                }
                size_t beta_random_intercept_raw_j_2_max__ = (M - 1);
                size_t beta_random_intercept_raw_j_1_max__ = N_grouping;
                for (size_t j_2__ = 0; j_2__ < beta_random_intercept_raw_j_2_max__; ++j_2__) {
                    for (size_t j_1__ = 0; j_1__ < beta_random_intercept_raw_j_1_max__; ++j_1__) {
                        vars__.push_back(beta_random_intercept_raw(j_1__, j_2__));
                    }
                }
                size_t mu_j_2_max__ = N;
                size_t mu_j_1_max__ = M;
                for (size_t j_2__ = 0; j_2__ < mu_j_2_max__; ++j_2__) {
                    for (size_t j_1__ = 0; j_1__ < mu_j_1_max__; ++j_1__) {
                        vars__.push_back(mu(j_1__, j_2__));
                    }
                }
                size_t mu_array_j_1_max__ = (N * M);
                for (size_t j_1__ = 0; j_1__ < mu_array_j_1_max__; ++j_1__) {
                    vars__.push_back(mu_array(j_1__));
                }
                size_t precision_array_j_1_max__ = (N * M);
                for (size_t j_1__ = 0; j_1__ < precision_array_j_1_max__; ++j_1__) {
                    vars__.push_back(precision_array(j_1__));
                }
            }
            if (!include_gqs__) return;
            // declare and define generated quantities
            current_statement_begin__ = 300;
            validate_non_negative_index("alpha_normalised", "A", A);
            validate_non_negative_index("alpha_normalised", "M", M);
            Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> alpha_normalised(A, M);
            stan::math::initialize(alpha_normalised, DUMMY_VAR__);
            stan::math::fill(alpha_normalised, DUMMY_VAR__);
            stan::math::assign(alpha_normalised,alpha);
            current_statement_begin__ = 302;
            validate_non_negative_index("beta_random_intercept", "N_grouping_WINDOWS_BUG_FIX", N_grouping_WINDOWS_BUG_FIX);
            validate_non_negative_index("beta_random_intercept", "M", M);
            Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> beta_random_intercept(N_grouping_WINDOWS_BUG_FIX, M);
            stan::math::initialize(beta_random_intercept, DUMMY_VAR__);
            stan::math::fill(beta_random_intercept, DUMMY_VAR__);
            current_statement_begin__ = 305;
            validate_non_negative_index("log_lik", "TNS", TNS);
            Eigen::Matrix<double, Eigen::Dynamic, 1> log_lik(TNS);
            stan::math::initialize(log_lik, DUMMY_VAR__);
            stan::math::fill(log_lik, DUMMY_VAR__);
            // generated quantities statements
            current_statement_begin__ = 307;
            if (as_bool(intercept_in_design)) {
                current_statement_begin__ = 308;
                if (as_bool(logical_gt(A, 1))) {
                    current_statement_begin__ = 308;
                    for (int a = 2; a <= A; ++a) {
                        current_statement_begin__ = 308;
                        stan::model::assign(alpha_normalised, 
                                    stan::model::cons_list(stan::model::index_uni(a), stan::model::nil_index_list()), 
                                    subtract(get_base1(alpha, a, "alpha", 1), multiply(get_base1(beta, a, "beta", 1), get_base1(prec_coeff, 2, "prec_coeff", 1))), 
                                    "assigning variable alpha_normalised");
                    }
                }
            } else {
                current_statement_begin__ = 311;
                for (int a = 1; a <= A; ++a) {
                    current_statement_begin__ = 311;
                    stan::model::assign(alpha_normalised, 
                                stan::model::cons_list(stan::model::index_uni(a), stan::model::nil_index_list()), 
                                subtract(get_base1(alpha, a, "alpha", 1), multiply(get_base1(beta, a, "beta", 1), get_base1(prec_coeff, 2, "prec_coeff", 1))), 
                                "assigning variable alpha_normalised");
                }
            }
            current_statement_begin__ = 315;
            if (as_bool(logical_eq(N_grouping, 0))) {
                current_statement_begin__ = 315;
                stan::model::assign(beta_random_intercept, 
                            stan::model::cons_list(stan::model::index_uni(1), stan::model::nil_index_list()), 
                            rep_row_vector(0.0, M), 
                            "assigning variable beta_random_intercept");
            } else {
                current_statement_begin__ = 319;
                stan::model::assign(beta_random_intercept, 
                            stan::model::cons_list(stan::model::index_omni(), stan::model::cons_list(stan::model::index_min_max(1, (M - 1)), stan::model::nil_index_list())), 
                            beta_random_intercept_raw, 
                            "assigning variable beta_random_intercept");
                current_statement_begin__ = 320;
                for (int n = 1; n <= N_grouping; ++n) {
                    current_statement_begin__ = 320;
                    stan::model::assign(beta_random_intercept, 
                                stan::model::cons_list(stan::model::index_uni(n), stan::model::cons_list(stan::model::index_uni(M), stan::model::nil_index_list())), 
                                -(sum(stan::model::rvalue(beta_random_intercept_raw, stan::model::cons_list(stan::model::index_uni(n), stan::model::cons_list(stan::model::index_omni(), stan::model::nil_index_list())), "beta_random_intercept_raw"))), 
                                "assigning variable beta_random_intercept");
                }
            }
            current_statement_begin__ = 324;
            if (as_bool(logical_eq(enable_loo, 1))) {
                current_statement_begin__ = 325;
                for (int n = 1; n <= TNS; ++n) {
                    current_statement_begin__ = 326;
                    stan::model::assign(log_lik, 
                                stan::model::cons_list(stan::model::index_uni(n), stan::model::nil_index_list()), 
                                beta_binomial_log(get_base1(y_array, get_base1(truncation_not_idx, n, "truncation_not_idx", 1), "y_array", 1), get_base1(exposure_array, get_base1(truncation_not_idx, n, "truncation_not_idx", 1), "exposure_array", 1), (get_base1(mu_array, get_base1(truncation_not_idx, n, "truncation_not_idx", 1), "mu_array", 1) * get_base1(precision_array, get_base1(truncation_not_idx, n, "truncation_not_idx", 1), "precision_array", 1)), ((1.0 - get_base1(mu_array, get_base1(truncation_not_idx, n, "truncation_not_idx", 1), "mu_array", 1)) * get_base1(precision_array, get_base1(truncation_not_idx, n, "truncation_not_idx", 1), "precision_array", 1))), 
                                "assigning variable log_lik");
                }
            }
            // validate, write generated quantities
            current_statement_begin__ = 300;
            size_t alpha_normalised_j_2_max__ = M;
            size_t alpha_normalised_j_1_max__ = A;
            for (size_t j_2__ = 0; j_2__ < alpha_normalised_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < alpha_normalised_j_1_max__; ++j_1__) {
                    vars__.push_back(alpha_normalised(j_1__, j_2__));
                }
            }
            current_statement_begin__ = 302;
            size_t beta_random_intercept_j_2_max__ = M;
            size_t beta_random_intercept_j_1_max__ = N_grouping_WINDOWS_BUG_FIX;
            for (size_t j_2__ = 0; j_2__ < beta_random_intercept_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < beta_random_intercept_j_1_max__; ++j_1__) {
                    vars__.push_back(beta_random_intercept(j_1__, j_2__));
                }
            }
            current_statement_begin__ = 305;
            size_t log_lik_j_1_max__ = TNS;
            for (size_t j_1__ = 0; j_1__ < log_lik_j_1_max__; ++j_1__) {
                vars__.push_back(log_lik(j_1__));
            }
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(e, current_statement_begin__, prog_reader__());
            // Next line prevents compiler griping about no return
            throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
        }
    }
    template <typename RNG>
    void write_array(RNG& base_rng,
                     Eigen::Matrix<double,Eigen::Dynamic,1>& params_r,
                     Eigen::Matrix<double,Eigen::Dynamic,1>& vars,
                     bool include_tparams = true,
                     bool include_gqs = true,
                     std::ostream* pstream = 0) const {
      std::vector<double> params_r_vec(params_r.size());
      for (int i = 0; i < params_r.size(); ++i)
        params_r_vec[i] = params_r(i);
      std::vector<double> vars_vec;
      std::vector<int> params_i_vec;
      write_array(base_rng, params_r_vec, params_i_vec, vars_vec, include_tparams, include_gqs, pstream);
      vars.resize(vars_vec.size());
      for (int i = 0; i < vars.size(); ++i)
        vars(i) = vars_vec[i];
    }
    std::string model_name() const {
        return "model_glm_multi_beta_binomial";
    }
    void constrained_param_names(std::vector<std::string>& param_names__,
                                 bool include_tparams__ = true,
                                 bool include_gqs__ = true) const {
        std::stringstream param_name_stream__;
        size_t beta_raw_raw_j_2_max__ = (M - 1);
        size_t beta_raw_raw_j_1_max__ = C;
        for (size_t j_2__ = 0; j_2__ < beta_raw_raw_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < beta_raw_raw_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "beta_raw_raw" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        size_t alpha_j_2_max__ = M;
        size_t alpha_j_1_max__ = A;
        for (size_t j_2__ = 0; j_2__ < alpha_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < alpha_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "alpha" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        size_t prec_coeff_k_0_max__ = 2;
        for (size_t k_0__ = 0; k_0__ < prec_coeff_k_0_max__; ++k_0__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "prec_coeff" << '.' << k_0__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        param_name_stream__.str(std::string());
        param_name_stream__ << "prec_sd";
        param_names__.push_back(param_name_stream__.str());
        param_name_stream__.str(std::string());
        param_name_stream__ << "mix_p";
        param_names__.push_back(param_name_stream__.str());
        size_t random_intercept_raw_j_2_max__ = (M - 1);
        size_t random_intercept_raw_j_1_max__ = (N_random_intercepts * logical_gt(N_random_intercepts, 0));
        for (size_t j_2__ = 0; j_2__ < random_intercept_raw_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < random_intercept_raw_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "random_intercept_raw" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        size_t random_intercept_sigma_mu_k_0_max__ = logical_gt(N_random_intercepts, 0);
        for (size_t k_0__ = 0; k_0__ < random_intercept_sigma_mu_k_0_max__; ++k_0__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "random_intercept_sigma_mu" << '.' << k_0__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        size_t random_intercept_sigma_sigma_k_0_max__ = logical_gt(N_random_intercepts, 0);
        for (size_t k_0__ = 0; k_0__ < random_intercept_sigma_sigma_k_0_max__; ++k_0__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "random_intercept_sigma_sigma" << '.' << k_0__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        size_t random_intercept_sigma_raw_j_1_max__ = ((M - 1) * logical_gt(N_random_intercepts, 0));
        for (size_t j_1__ = 0; j_1__ < random_intercept_sigma_raw_j_1_max__; ++j_1__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "random_intercept_sigma_raw" << '.' << j_1__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        size_t zero_random_intercept_k_0_max__ = logical_gt(N_random_intercepts, 0);
        for (size_t k_0__ = 0; k_0__ < zero_random_intercept_k_0_max__; ++k_0__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "zero_random_intercept" << '.' << k_0__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        if (!include_gqs__ && !include_tparams__) return;
        if (include_tparams__) {
            size_t beta_raw_j_2_max__ = M;
            size_t beta_raw_j_1_max__ = C;
            for (size_t j_2__ = 0; j_2__ < beta_raw_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < beta_raw_j_1_max__; ++j_1__) {
                    param_name_stream__.str(std::string());
                    param_name_stream__ << "beta_raw" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                    param_names__.push_back(param_name_stream__.str());
                }
            }
            size_t precision_j_2_max__ = N;
            size_t precision_j_1_max__ = M;
            for (size_t j_2__ = 0; j_2__ < precision_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < precision_j_1_max__; ++j_1__) {
                    param_name_stream__.str(std::string());
                    param_name_stream__ << "precision" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                    param_names__.push_back(param_name_stream__.str());
                }
            }
            size_t beta_j_2_max__ = M;
            size_t beta_j_1_max__ = C;
            for (size_t j_2__ = 0; j_2__ < beta_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < beta_j_1_max__; ++j_1__) {
                    param_name_stream__.str(std::string());
                    param_name_stream__ << "beta" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                    param_names__.push_back(param_name_stream__.str());
                }
            }
            size_t random_intercept_minus_sum_j_2_max__ = (M - 1);
            size_t random_intercept_minus_sum_j_1_max__ = N_minus_sum;
            for (size_t j_2__ = 0; j_2__ < random_intercept_minus_sum_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < random_intercept_minus_sum_j_1_max__; ++j_1__) {
                    param_name_stream__.str(std::string());
                    param_name_stream__ << "random_intercept_minus_sum" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                    param_names__.push_back(param_name_stream__.str());
                }
            }
            size_t random_intercept_sigma_j_1_max__ = (M - 1);
            for (size_t j_1__ = 0; j_1__ < random_intercept_sigma_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "random_intercept_sigma" << '.' << j_1__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
            size_t beta_random_intercept_raw_j_2_max__ = (M - 1);
            size_t beta_random_intercept_raw_j_1_max__ = N_grouping;
            for (size_t j_2__ = 0; j_2__ < beta_random_intercept_raw_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < beta_random_intercept_raw_j_1_max__; ++j_1__) {
                    param_name_stream__.str(std::string());
                    param_name_stream__ << "beta_random_intercept_raw" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                    param_names__.push_back(param_name_stream__.str());
                }
            }
            size_t mu_j_2_max__ = N;
            size_t mu_j_1_max__ = M;
            for (size_t j_2__ = 0; j_2__ < mu_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < mu_j_1_max__; ++j_1__) {
                    param_name_stream__.str(std::string());
                    param_name_stream__ << "mu" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                    param_names__.push_back(param_name_stream__.str());
                }
            }
            size_t mu_array_j_1_max__ = (N * M);
            for (size_t j_1__ = 0; j_1__ < mu_array_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "mu_array" << '.' << j_1__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
            size_t precision_array_j_1_max__ = (N * M);
            for (size_t j_1__ = 0; j_1__ < precision_array_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "precision_array" << '.' << j_1__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        if (!include_gqs__) return;
        size_t alpha_normalised_j_2_max__ = M;
        size_t alpha_normalised_j_1_max__ = A;
        for (size_t j_2__ = 0; j_2__ < alpha_normalised_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < alpha_normalised_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "alpha_normalised" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        size_t beta_random_intercept_j_2_max__ = M;
        size_t beta_random_intercept_j_1_max__ = N_grouping_WINDOWS_BUG_FIX;
        for (size_t j_2__ = 0; j_2__ < beta_random_intercept_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < beta_random_intercept_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "beta_random_intercept" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        size_t log_lik_j_1_max__ = TNS;
        for (size_t j_1__ = 0; j_1__ < log_lik_j_1_max__; ++j_1__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "log_lik" << '.' << j_1__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
    }
    void unconstrained_param_names(std::vector<std::string>& param_names__,
                                   bool include_tparams__ = true,
                                   bool include_gqs__ = true) const {
        std::stringstream param_name_stream__;
        size_t beta_raw_raw_j_2_max__ = (M - 1);
        size_t beta_raw_raw_j_1_max__ = C;
        for (size_t j_2__ = 0; j_2__ < beta_raw_raw_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < beta_raw_raw_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "beta_raw_raw" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        size_t alpha_j_2_max__ = M;
        size_t alpha_j_1_max__ = A;
        for (size_t j_2__ = 0; j_2__ < alpha_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < alpha_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "alpha" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        size_t prec_coeff_k_0_max__ = 2;
        for (size_t k_0__ = 0; k_0__ < prec_coeff_k_0_max__; ++k_0__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "prec_coeff" << '.' << k_0__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        param_name_stream__.str(std::string());
        param_name_stream__ << "prec_sd";
        param_names__.push_back(param_name_stream__.str());
        param_name_stream__.str(std::string());
        param_name_stream__ << "mix_p";
        param_names__.push_back(param_name_stream__.str());
        size_t random_intercept_raw_j_2_max__ = (M - 1);
        size_t random_intercept_raw_j_1_max__ = (N_random_intercepts * logical_gt(N_random_intercepts, 0));
        for (size_t j_2__ = 0; j_2__ < random_intercept_raw_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < random_intercept_raw_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "random_intercept_raw" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        size_t random_intercept_sigma_mu_k_0_max__ = logical_gt(N_random_intercepts, 0);
        for (size_t k_0__ = 0; k_0__ < random_intercept_sigma_mu_k_0_max__; ++k_0__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "random_intercept_sigma_mu" << '.' << k_0__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        size_t random_intercept_sigma_sigma_k_0_max__ = logical_gt(N_random_intercepts, 0);
        for (size_t k_0__ = 0; k_0__ < random_intercept_sigma_sigma_k_0_max__; ++k_0__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "random_intercept_sigma_sigma" << '.' << k_0__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        size_t random_intercept_sigma_raw_j_1_max__ = ((M - 1) * logical_gt(N_random_intercepts, 0));
        for (size_t j_1__ = 0; j_1__ < random_intercept_sigma_raw_j_1_max__; ++j_1__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "random_intercept_sigma_raw" << '.' << j_1__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        size_t zero_random_intercept_k_0_max__ = logical_gt(N_random_intercepts, 0);
        for (size_t k_0__ = 0; k_0__ < zero_random_intercept_k_0_max__; ++k_0__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "zero_random_intercept" << '.' << k_0__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        if (!include_gqs__ && !include_tparams__) return;
        if (include_tparams__) {
            size_t beta_raw_j_2_max__ = M;
            size_t beta_raw_j_1_max__ = C;
            for (size_t j_2__ = 0; j_2__ < beta_raw_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < beta_raw_j_1_max__; ++j_1__) {
                    param_name_stream__.str(std::string());
                    param_name_stream__ << "beta_raw" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                    param_names__.push_back(param_name_stream__.str());
                }
            }
            size_t precision_j_2_max__ = N;
            size_t precision_j_1_max__ = M;
            for (size_t j_2__ = 0; j_2__ < precision_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < precision_j_1_max__; ++j_1__) {
                    param_name_stream__.str(std::string());
                    param_name_stream__ << "precision" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                    param_names__.push_back(param_name_stream__.str());
                }
            }
            size_t beta_j_2_max__ = M;
            size_t beta_j_1_max__ = C;
            for (size_t j_2__ = 0; j_2__ < beta_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < beta_j_1_max__; ++j_1__) {
                    param_name_stream__.str(std::string());
                    param_name_stream__ << "beta" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                    param_names__.push_back(param_name_stream__.str());
                }
            }
            size_t random_intercept_minus_sum_j_2_max__ = (M - 1);
            size_t random_intercept_minus_sum_j_1_max__ = N_minus_sum;
            for (size_t j_2__ = 0; j_2__ < random_intercept_minus_sum_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < random_intercept_minus_sum_j_1_max__; ++j_1__) {
                    param_name_stream__.str(std::string());
                    param_name_stream__ << "random_intercept_minus_sum" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                    param_names__.push_back(param_name_stream__.str());
                }
            }
            size_t random_intercept_sigma_j_1_max__ = (M - 1);
            for (size_t j_1__ = 0; j_1__ < random_intercept_sigma_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "random_intercept_sigma" << '.' << j_1__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
            size_t beta_random_intercept_raw_j_2_max__ = (M - 1);
            size_t beta_random_intercept_raw_j_1_max__ = N_grouping;
            for (size_t j_2__ = 0; j_2__ < beta_random_intercept_raw_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < beta_random_intercept_raw_j_1_max__; ++j_1__) {
                    param_name_stream__.str(std::string());
                    param_name_stream__ << "beta_random_intercept_raw" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                    param_names__.push_back(param_name_stream__.str());
                }
            }
            size_t mu_j_2_max__ = N;
            size_t mu_j_1_max__ = M;
            for (size_t j_2__ = 0; j_2__ < mu_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < mu_j_1_max__; ++j_1__) {
                    param_name_stream__.str(std::string());
                    param_name_stream__ << "mu" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                    param_names__.push_back(param_name_stream__.str());
                }
            }
            size_t mu_array_j_1_max__ = (N * M);
            for (size_t j_1__ = 0; j_1__ < mu_array_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "mu_array" << '.' << j_1__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
            size_t precision_array_j_1_max__ = (N * M);
            for (size_t j_1__ = 0; j_1__ < precision_array_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "precision_array" << '.' << j_1__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        if (!include_gqs__) return;
        size_t alpha_normalised_j_2_max__ = M;
        size_t alpha_normalised_j_1_max__ = A;
        for (size_t j_2__ = 0; j_2__ < alpha_normalised_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < alpha_normalised_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "alpha_normalised" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        size_t beta_random_intercept_j_2_max__ = M;
        size_t beta_random_intercept_j_1_max__ = N_grouping_WINDOWS_BUG_FIX;
        for (size_t j_2__ = 0; j_2__ < beta_random_intercept_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < beta_random_intercept_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "beta_random_intercept" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        size_t log_lik_j_1_max__ = TNS;
        for (size_t j_1__ = 0; j_1__ < log_lik_j_1_max__; ++j_1__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "log_lik" << '.' << j_1__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
    }
}; // model
}  // namespace
typedef model_glm_multi_beta_binomial_namespace::model_glm_multi_beta_binomial stan_model;
#ifndef USING_R
stan::model::model_base& new_model(
        stan::io::var_context& data_context,
        unsigned int seed,
        std::ostream* msg_stream) {
  stan_model* m = new stan_model(data_context, seed, msg_stream);
  return *m;
}
#endif
#endif
